      PROGRAM GETJPI
C----------------------------------------------------------------------*
C     PROGRAM:      GETJPI                                             *
C----------------------------------------------------------------------*
C     LANGUAGE:     VAX-11 FORTRAN V2.0-2                              *
C     SYSTEM:       VAX-11/780                                         *
C                   MOSTEK CORPORATION                                 *
C                   COMPUTER AIDS TO DESIGN DEPARTMENT                 *
C                   1215 WEST CROSBY ROAD                              *
C                   CARROLLTON, TEXAS  75006                           *
C                   (214)  323-8813                                    *
C----------------------------------------------------------------------*
C     PROGRAMMER:   KEVIN KLUGHART                                     *
C----------------------------------------------------------------------*
C     DATE:         04-05-81 @ 14:00 CDST                              *
C----------------------------------------------------------------------*
C     PURPOSE:      THIS PROGRAM CONTINUALLY DISPLAYS ALL KNOWN        *
C                   PROCESS PARAMETERS FOR A GIVEN PROCESS.            *
C----------------------------------------------------------------------*
C     EXTERNALS:    STRING LIBRARY                                     *
C                   SYS$JPI PROCESS INFORMATION SUBROUTINE             *
C----------------------------------------------------------------------*
C     PARAMETERS                                                       *
C----------------------------------------------------------------------*
C     NUMERIC PARAMETERS                                               *
C----------------------------------------------------------------------*
C     USEFUL CONSTANTS                                                 *
C----------------------------------------------------------------------*
      PARAMETER EIGHT            = 8              ! USEFUL CONSTANT
      PARAMETER FIVE             = 5              ! USEFUL CONSTANT
      PARAMETER FOUR             = 4              ! USEFUL CONSTANT
      PARAMETER FULL             = 15             ! FULL ERROR MESSAGES
      PARAMETER MAX              = 511            ! MAXIMUM STRING LENGTH
      PARAMETER MAXJPI           = 60             ! MAXIMUM # OF JPI VALUES
      PARAMETER MAXNAM           = 15             ! MAXIMUM # CHARS IN NAME
      PARAMETER MAXPCB           = 24             ! MAXIMUM # OF PCB VALUES
      PARAMETER MAXPRV           = 30             ! MAXIMUM # OF PRV VALUES
      PARAMETER MAXSCH           = 14             ! MAXIMUM # OF SCH VALUES
      PARAMETER NINE             = 9              ! USEFUL CONSTANT
      PARAMETER ONE              = 1              ! USEFUL CONSTANT
      PARAMETER PAGE             = 24             ! PAGE LENGTH
      PARAMETER SEVEN            = 7              ! USEFUL CONSTANT
      PARAMETER SIX              = 6              ! USEFUL CONSTANT
      PARAMETER TEN              = 10             ! USEFUL CONSTANT
      PARAMETER THREE            = 3              ! USEFUL CONSTANT
      PARAMETER TWO              = 2              ! USEFUL CONSTANT
      PARAMETER WIDLB            = 36             ! MAXIMUM LABEL WIDTH
      PARAMETER WIDTH            = 80             ! PAGE WIDTH
      PARAMETER WID              = WIDTH/FOUR     ! LABEL WIDTH
      PARAMETER WILDCARD         = -ONE           ! WILDCARD PROCESS SEARCH
      PARAMETER ZERO             = 0              ! USEFUL CONSTANT
C----------------------------------------------------------------------*
C     JOB PROCESS INFORMATION DISPLAY TYPE PARAMETERS                  *
C----------------------------------------------------------------------*
      PARAMETER BYTEHEX          = ZERO           ! BYTE HEX FORMAT
      PARAMETER BYTEOCT          = BYTEHEX+ONE    ! BYTE OCTAL FORMAT
      PARAMETER DECIMAL          = BYTEOCT+ONE    ! INTEGER DECIMAL
      PARAMETER LONGHEX          = DECIMAL+ONE    ! LONGWORD HEX FORMAT
      PARAMETER PRIVMSK          = LONGHEX+ONE    ! PRIVILEGE MASK
      PARAMETER SPECIAL          = PRIVMSK+ONE    ! SPECIAL FORMAT
      PARAMETER STRING           = SPECIAL+ONE    ! CHARACTER FORMAT
      PARAMETER SYSTIME          = STRING+ONE     ! SYSTEM TIME FORMAT
      PARAMETER WORDHEX          = SYSTIME+ONE    ! WORD HEX FORMAT
      PARAMETER WORDOCT          = WORDHEX+ONE    ! WORD OCTAL FORMAT
C----------------------------------------------------------------------*
C     CHARACTER PARAMETERS                                             *
C----------------------------------------------------------------------*
      PARAMETER BLANK            = ' '            ! DEFINE SPACE CHARACTER
      PARAMETER COMMA            = ','            ! PRIVILEGE DELIMITER
      PARAMETER LEFT             = '['            ! LEFT BRACKET
      PARAMETER RIGHT            = ']'            ! RIGHT BRACKET
C----------------------------------------------------------------------*
C     EXTERNALS                                                        *
C----------------------------------------------------------------------*
C     SYS$GETJPI JOB PROCESS INFORMATION ITEM CODES                    *
C----------------------------------------------------------------------*
      EXTERNAL JPI$_ACCOUNT
      EXTERNAL JPI$_APTCNT
      EXTERNAL JPI$_ASTACT
      EXTERNAL JPI$_ASTCNT
      EXTERNAL JPI$_ASTEN
      EXTERNAL JPI$_ASTLM
      EXTERNAL JPI$_AUTHPRIV
      EXTERNAL JPI$_BIOCNT
      EXTERNAL JPI$_BIOLM
      EXTERNAL JPI$_BUFIO
      EXTERNAL JPI$_BYTCNT
      EXTERNAL JPI$_BYTLM
      EXTERNAL JPI$_CPULIM
      EXTERNAL JPI$_CPUTIM
      EXTERNAL JPI$_CURPRIV
      EXTERNAL JPI$_DFPFC
      EXTERNAL JPI$_DFWSCNT
      EXTERNAL JPI$_DIOCNT
      EXTERNAL JPI$_DIOLM
      EXTERNAL JPI$_DIRIO
      EXTERNAL JPI$_EFCS
      EXTERNAL JPI$_EFCU
      EXTERNAL JPI$_EFWM
      EXTERNAL JPI$_EXCVEC
      EXTERNAL JPI$_FILCNT
      EXTERNAL JPI$_FILLM
      EXTERNAL JPI$_FINALEXC
      EXTERNAL JPI$_FREP0VA
      EXTERNAL JPI$_FREP1VA
      EXTERNAL JPI$_GPGCNT
      EXTERNAL JPI$_GRP
      EXTERNAL JPI$_IMAGNAME
      EXTERNAL JPI$_IMAGPRIV
      EXTERNAL JPI$_LOGINTIM
      EXTERNAL JPI$_MEM
      EXTERNAL JPI$_OWNER
      EXTERNAL JPI$_PAGEFLTS
      EXTERNAL JPI$_PGFLQUOTA
      EXTERNAL JPI$_PID
      EXTERNAL JPI$_PPGCNT
      EXTERNAL JPI$_PRCCNT
      EXTERNAL JPI$_PRCLM
      EXTERNAL JPI$_PRCNAM
      EXTERNAL JPI$_PRI
      EXTERNAL JPI$_PRIB
      EXTERNAL JPI$_PROCPRIV
      EXTERNAL JPI$_STATE
      EXTERNAL JPI$_STS
      EXTERNAL JPI$_TERMINAL
      EXTERNAL JPI$_TMBU
      EXTERNAL JPI$_TQCNT
      EXTERNAL JPI$_TQLM
      EXTERNAL JPI$_UIC
      EXTERNAL JPI$_USERNAME
      EXTERNAL JPI$_VIRTPEAK
      EXTERNAL JPI$_VOLUMES
      EXTERNAL JPI$_WSAUTH
      EXTERNAL JPI$_WSPEAK
      EXTERNAL JPI$_WSQUOTA
      EXTERNAL JPI$_WSSIZE
C----------------------------------------------------------------------*
C     $PCBDEF PROCESS CONTROL BLOCK DEFINITIONS (STATUS FLAGS)         *
C----------------------------------------------------------------------*
      EXTERNAL PCB$V_ASTPEN
      EXTERNAL PCB$V_BATCH
      EXTERNAL PCB$V_DELPEN
      EXTERNAL PCB$V_FORCPEN
      EXTERNAL PCB$V_HIBER
      EXTERNAL PCB$V_INQUAN
      EXTERNAL PCB$V_LOGIN
      EXTERNAL PCB$V_NETWRK
      EXTERNAL PCB$V_NOACNT
      EXTERNAL PCB$V_NODELET
      EXTERNAL PCB$V_PHDRES
      EXTERNAL PCB$V_PSWAPM
      EXTERNAL PCB$V_PWRAST
      EXTERNAL PCB$V_RES
      EXTERNAL PCB$V_RESPEN
      EXTERNAL PCB$V_SSFEXC
      EXTERNAL PCB$V_SSFEXCE
      EXTERNAL PCB$V_SSFEXCS
      EXTERNAL PCB$V_SSFEXCU
      EXTERNAL PCB$V_SSRWAIT
      EXTERNAL PCB$V_SUSPEN
      EXTERNAL PCB$V_SWPVBN
      EXTERNAL PCB$V_WAKEPEN
      EXTERNAL PCB$V_WALL
C----------------------------------------------------------------------*
C     $PRVDEF PROCESS PRIVILEGE DEFINITIONS                            *
C----------------------------------------------------------------------*
      EXTERNAL PRV$V_ALLSPOOL
      EXTERNAL PRV$V_BUGCHK
      EXTERNAL PRV$V_BYPASS
      EXTERNAL PRV$V_CMEXEC
      EXTERNAL PRV$V_CMKRNL
      EXTERNAL PRV$V_DETACH
      EXTERNAL PRV$V_DIAGNOSE
      EXTERNAL PRV$V_EXQUOTA
      EXTERNAL PRV$V_GROUP
      EXTERNAL PRV$V_GRPNAM
      EXTERNAL PRV$V_LOG_IO
      EXTERNAL PRV$V_MOUNT
      EXTERNAL PRV$V_NETMBX
      EXTERNAL PRV$V_NOACNT
      EXTERNAL PRV$V_OPER
      EXTERNAL PRV$V_PFNMAP
      EXTERNAL PRV$V_PHY_IO
      EXTERNAL PRV$V_PRMCEB
      EXTERNAL PRV$V_PRMGBL
      EXTERNAL PRV$V_PRMMBX
      EXTERNAL PRV$V_PSWAPM
      EXTERNAL PRV$V_SETPRI
      EXTERNAL PRV$V_SETPRV
      EXTERNAL PRV$V_SHMEM
      EXTERNAL PRV$V_SYSGBL
      EXTERNAL PRV$V_SYSNAM
      EXTERNAL PRV$V_SYSPRV
      EXTERNAL PRV$V_TMPMBX
      EXTERNAL PRV$V_VOLPRO
      EXTERNAL PRV$V_WORLD
C----------------------------------------------------------------------*
C     $STATEDEF PROCESS STATE DEFINITIONS                              *
C----------------------------------------------------------------------*
      EXTERNAL SCH$C_CEF
      EXTERNAL SCH$C_COLPG
      EXTERNAL SCH$C_COM
      EXTERNAL SCH$C_COMO
      EXTERNAL SCH$C_CUR
      EXTERNAL SCH$C_FPG
      EXTERNAL SCH$C_HIB
      EXTERNAL SCH$C_HIBO
      EXTERNAL SCH$C_LEF
      EXTERNAL SCH$C_LEFO
      EXTERNAL SCH$C_MWAIT
      EXTERNAL SCH$C_PFW
      EXTERNAL SCH$C_SUSP
      EXTERNAL SCH$C_SUSPO
C----------------------------------------------------------------------*
C     SYSTEM SERVICE STATUS CODES                                      *
C----------------------------------------------------------------------*
      EXTERNAL SS$_ACCVIO
      EXTERNAL SS$_BADPARAM
      EXTERNAL SS$_IVLOGNAM
      EXTERNAL SS$_NOMOREPROC
      EXTERNAL SS$_NONEXPR
      EXTERNAL SS$_NOPRIV
      EXTERNAL SS$_NORMAL
      EXTERNAL SS$_SUSPENDED
C----------------------------------------------------------------------*
C     CHARACTER                                                        *
C----------------------------------------------------------------------*
      CHARACTER*(WIDLB) JPI_LABEL      (MAXJPI)
      CHARACTER*( WID ) JPI_NAME       (MAXJPI)
      CHARACTER*(WIDTH) JPI_STRING
      CHARACTER*( MAX ) OUTPUT
      CHARACTER*( WID ) PCB_NAME       (MAXPCB)
      CHARACTER*(WIDTH) PROCESS
      CHARACTER*( WID ) PRV_NAME       (MAXPRV)
      CHARACTER*(WIDTH) SCH_NAME       (MAXSCH)
C----------------------------------------------------------------------*
C     INTEGER*4                                                        *
C----------------------------------------------------------------------*
      INTEGER*4 DISPLAY
      INTEGER*4 JPI
      INTEGER*4 JPIPTR
      INTEGER*4 JPITYP
      INTEGER*4 JPI_ITEM       (MAXJPI)
      INTEGER*4 JPI_PAGE       (MAXJPI)
      INTEGER*4 JPI_TYPE       (MAXJPI)
      INTEGER*4 JPI_VALUE      ( TWO  )
      INTEGER*4 LIB$GET_FOREIGN
      INTEGER*4 LIB$PUT_OUTPUT
      INTEGER*4 LIM
      INTEGER*4 LIMIT
      INTEGER*4 MASK
      INTEGER*4 PCB_ITEM       (MAXPCB)
      INTEGER*4 PID
      INTEGER*4 PID_SEARCH
      INTEGER*4 POINTER
      INTEGER*4 PRV_ITEM       (MAXPRV)
      INTEGER*4 SCH_ITEM       (MAXSCH)
      INTEGER*4 STATUS
      INTEGER*4 SYS$JPI
      INTEGER*4 USRJPI
C----------------------------------------------------------------------*
C     LOGICAL*4                                                        *
C----------------------------------------------------------------------*
      LOGICAL*4 ERROR
      LOGICAL*4 NODATA
C----------------------------------------------------------------------*
C     DATA                                                             *
C----------------------------------------------------------------------*
C                                                                      *
C     LABELS FOR JOB PROCESS INFORMATION                               *
C                                                                      *
C----------------------------------------------------------------------*
      DATA JPI_LABEL         /  'Account name:                     ',
     1                          'Active Page Table Count:          ',
     2                          'Access Modes with Active ASTs:    ',
     3                          'Remaining AST Quota:              ',
     4                          'Access Modes with ASTs Enabled:   ',
     5                          'AST Limit Quota:                  ',
     6                          'Authorized Privileges:            ',
     7                          'Remaining Buffered I/O Quota:     ',
     8                          'Buffered I/O Limit Quota:         ',
     9                          'Count of Buffered I/O Operations: ',
     A                          'Remaining Buffered I/O Byte Count:',
     1                          'Buffered I/O Byte Count Quota:    ',
     2                          'CPU Time Limit:                   ',
     3                          'Total CPU Time Used (10MS ticks): ',
     4                          'Current Process Privileges:       ',
     5                          'Default Page Fault Cluster Size:  ',
     6                          'Default Working Set Size:         ',
     7                          'Remaining Direct I/O Quota:       ',
     8                          'Direct I/O Limit Quota:           ',
     9                          'Count of Direct I/O Operations:   ',
     B                          'Local Event Flags (00-31):        ',
     1                          'Local Event Flags (32-63):        ',
     2                          'Event Flag Wait Mask:             ',
     3                          'Address of Exception Vector List: ',
     4                          'Remaining Open File Quota:        ',
     5                          'Open File Quota:                  ',
     6                          'Final Exception Vector List Addr: ',
     7                          'First Free Page (program region): ',
     8                          'First Free Page (control region): ',
     9                          'Global Page Count in Working Set: ',
     C                          'Group Number of UIC:              ',
     1                          'Current Image File Name:          ',
     2                          'Image Installation Privileges:    ',
     3                          'Process Creation Time:            ',
     4                          'Member Number of UIC:             ',
     5                          'PID of Process Owner:             ',
     6                          'Page Faults:                      ',
     7                          'Paging File Quota:                ',
     8                          'Process Identification:           ',
     9                          'Process Page Count in Working Set:',
     D                          'Subprocess Count:                 ',
     1                          'Subprocess Quota:                 ',
     2                          'Process Name:                     ',
     3                          'Current Process Priority:         ',
     4                          'Process Base Priority:            ',
     5                          'Default Process Privileges:       ',
     6                          'Process State:                    ',
     7                          'Process Status Flags:             ',
     8                          'Login Terminal Name:              ',
     9                          'Termination Mailbox Unit Number:  ',
     E                          'Remaining Timer Queue Entry Quota:',
     1                          'Timer Queue Entry Quota:          ',
     2                          'User Identification Code (UIC):   ',
     3                          'User Name:                        ',
     4                          'Peak Virtual Address Size:        ',
     5                          'Currently Mounted Volumes:        ',
     6                          'Max Authorized Working Set Size:  ',
     7                          'Working Set Peak:                 ',
     8                          'Working Set Size Quota:           ',
     9                          'Current Working Set Size:         '  /
C----------------------------------------------------------------------*
C                                                                      *
C     NAMES FOR JOB PROCESS INFORMATION                                *
C                                                                      *
C----------------------------------------------------------------------*
      DATA JPI_NAME          /  'JPI$_ACCOUNT   ', 'JPI$_APTCNT    ',
     1                          'JPI$_ASTACT    ', 'JPI$_ASTCNT    ',
     2                          'JPI$_ASTEN     ', 'JPI$_ASTLM     ',
     3                          'JPI$_AUTHPRIV  ', 'JPI$_BIOCNT    ',
     4                          'JPI$_BIOLM     ', 'JPI$_BUFIO     ',
     5                          'JPI$_BYTCNT    ', 'JPI$_BYTLM     ',
     6                          'JPI$_CPULIM    ', 'JPI$_CPUTIM    ',
     7                          'JPI$_CURPRIV   ', 'JPI$_DFPFC     ',
     8                          'JPI$_DFWSCNT   ', 'JPI$_DIOCNT    ',
     9                          'JPI$_DIOLM     ', 'JPI$_DIRIO     ',
     A                          'JPI$_EFCS      ', 'JPI$_EFCU      ',
     1                          'JPI$_EFWM      ', 'JPI$_EXCVEC    ',
     2                          'JPI$_FILCNT    ', 'JPI$_FILLM     ',
     3                          'JPI$_FINALEXC  ', 'JPI$_FREP0VA   ',
     4                          'JPI$_FREP1VA   ', 'JPI$_GPGCNT    ',
     5                          'JPI$_GRP       ', 'JPI$_IMAGNAME  ',
     6                          'JPI$_IMAGPRIV  ', 'JPI$_LOGINTIM  ',
     7                          'JPI$_MEM       ', 'JPI$_OWNER     ',
     8                          'JPI$_PAGEFLTS  ', 'JPI$_PGFLQUOTA ',
     9                          'JPI$_PID       ', 'JPI$_PPGCNT    ',
     B                          'JPI$_PRCCNT    ', 'JPI$_PRCLM     ',
     1                          'JPI$_PRCNAM    ', 'JPI$_PRI       ',
     2                          'JPI$_PRIB      ', 'JPI$_PROCPRIV  ',
     3                          'JPI$_STATE     ', 'JPI$_STS       ',
     4                          'JPI$_TERMINAL  ', 'JPI$_TMBU      ',
     5                          'JPI$_TQCNT     ', 'JPI$_TQLM      ',
     6                          'JPI$_UIC       ', 'JPI$_USERNAME  ',
     7                          'JPI$_VIRTPEAK  ', 'JPI$_VOLUMES   ',
     8                          'JPI$_WSAUTH    ', 'JPI$_WSPEAK    ',
     9                          'JPI$_WSQUOTA   ', 'JPI$_WSSIZE    '  /
C----------------------------------------------------------------------*
C                                                                      *
C     DISPLAY OUTPUT TYPE FOR EACH OF THE JOB INFORMATION ITEMS        *
C                                                                      *
C----------------------------------------------------------------------*
      DATA JPI_TYPE          /  STRING           , DECIMAL          ,
     1                          DECIMAL          , DECIMAL          ,
     2                          LONGHEX          , DECIMAL          ,
     3                          PRIVMSK          , DECIMAL          ,
     4                          DECIMAL          , DECIMAL          ,
     5                          DECIMAL          , DECIMAL          ,
     6                          DECIMAL          , DECIMAL          ,
     7                          PRIVMSK          , DECIMAL          ,
     8                          DECIMAL          , DECIMAL          ,
     9                          DECIMAL          , DECIMAL          ,
     A                          LONGHEX          , LONGHEX          ,
     1                          LONGHEX          , LONGHEX          ,
     2                          DECIMAL          , DECIMAL          ,
     3                          LONGHEX          , LONGHEX          ,
     4                          LONGHEX          , DECIMAL          ,
     5                          BYTEOCT          , STRING           ,
     6                          PRIVMSK          , SYSTIME          ,
     7                          BYTEOCT          , LONGHEX          ,
     8                          DECIMAL          , DECIMAL          ,
     9                          LONGHEX          , DECIMAL          ,
     B                          DECIMAL          , DECIMAL          ,
     1                          STRING           , DECIMAL          ,
     2                          DECIMAL          , PRIVMSK          ,
     3                          SPECIAL          , SPECIAL          ,
     4                          STRING           , DECIMAL          ,
     5                          DECIMAL          , DECIMAL          ,
     6                          LONGHEX          , STRING           ,
     7                          LONGHEX          , DECIMAL          ,
     8                          DECIMAL          , DECIMAL          ,
     9                          DECIMAL          , DECIMAL            /
C----------------------------------------------------------------------*
C                                                                      *
C     PROCESS STATUS FLAG IDENTIFIERS                                  *
C                                                                      *
C----------------------------------------------------------------------*
      DATA PCB_NAME          /  'ASTPEN         ', 'BATCH          ',
     1                          'DELPEN         ', 'FORCPEN        ',
     2                          'HIBER          ', 'INQUAN         ',
     3                          'LOGIN          ', 'NETWRK         ',
     4                          'NOACNT         ', 'NODELET        ',
     5                          'PHDRES         ', 'PSWAPM         ',
     6                          'PWRAST         ', 'RES            ',
     7                          'RESPEN         ', 'SSFEXC         ',
     8                          'SSFEXCE        ', 'SSFEXCS        ',
     9                          'SSFEXCU        ', 'SSRWAIT        ',
     A                          'SUSPEN         ', 'SWPVBN         ',
     1                          'WAKEPEN        ', 'WALL           '  /
C----------------------------------------------------------------------*
C                                                                      *
C     PROCESS PRIVILEGE IDENTIFIERS                                    *
C                                                                      *
C----------------------------------------------------------------------*
      DATA PRV_NAME          /  'ALLSPOOL       ', 'BUGCHK         ',
     1                          'BYPASS         ', 'CMEXEC         ',
     2                          'CMKRNL         ', 'DETACH         ',
     3                          'DIAGNOSE       ', 'EXQUOTA        ',
     4                          'GROUP          ', 'GRPNAM         ',
     5                          'LOG_IO         ', 'MOUNT          ',
     6                          'NETMBX         ', 'NOACNT         ',
     7                          'OPER           ', 'PFNMAP         ',
     8                          'PHY_IO         ', 'PRMCEB         ',
     9                          'PRMGBL         ', 'PRMMBX         ',
     A                          'PSWAPM         ', 'SETPRI         ',
     1                          'SETPRV         ', 'SHMEM          ',
     2                          'SYSGBL         ', 'SYSNAM         ',
     3                          'SYSPRV         ', 'TMPMBX         ',
     4                          'VOLPRO         ', 'WORLD          '  /
C----------------------------------------------------------------------*
C                                                                      *
C     PROCESS STATE IDENTIFIERS                                        *
C                                                                      *
C----------------------------------------------------------------------*
      DATA SCH_NAME          /  'COMMON EVENT FLAG WAIT            ',
     1                          'COLLIDED PAGE WAIT                ',
     2                          'COMPUTE                           ',
     3                          'COMPUTE (OUT)                     ',
     4                          'CURRENT PROCESS                   ',
     5                          'FREE PAGE WAIT                    ',
     6                          'HIBERNATE WAIT                    ',
     7                          'HIBERNATE WAIT (OUT)              ',
     8                          'LOCAL EVENT FLAG WAIT             ',
     9                          'LOCAL EVENT FLAG WAIT (OUT)       ',
     A                          'MUTEX OR MISC. RESOURCE WAIT      ',
     1                          'PAGE FAULT WAIT                   ',
     2                          'SUSPENDED                         ',
     3                          'SUSPENDED (OUT)                   '  /
C----------------------------------------------------------------------*
C     SECTION 100                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C                                                                      *
C     INITIALIZATION                                                   *
C                                                                      *
C                                                                      *
C----------------------------------------------------------------------*
C     ZERO OUT UNUSED ELEMENTS OF THE DATA BASE                        *
C----------------------------------------------------------------------*
  100 CONTINUE
      
      DO POINTER=ONE,MAXJPI
           JPI_ITEM(POINTER)=ZERO
           JPI_PAGE(POINTER)=ZERO
      ENDDO

      DO POINTER=ONE,MAXPCB
           PCB_ITEM(POINTER)=ZERO
      ENDDO

      DO POINTER=ONE,MAXPRV
           PRV_ITEM(POINTER)=ZERO
      ENDDO

      DO POINTER=ONE,MAXSCH
           SCH_ITEM(POINTER)=ZERO
      ENDDO
C----------------------------------------------------------------------*
C                                                                      *
C     INITIALIZE INDIVIDUAL ITEM CODES IN THE DATA BASE                *
C                                                                      *
C----------------------------------------------------------------------*
      JPI_ITEM(001)=%LOC(JPI$_ACCOUNT)
      JPI_ITEM(002)=%LOC(JPI$_APTCNT)
      JPI_ITEM(003)=%LOC(JPI$_ASTACT)
      JPI_ITEM(004)=%LOC(JPI$_ASTCNT)
      JPI_ITEM(005)=%LOC(JPI$_ASTEN)
      JPI_ITEM(006)=%LOC(JPI$_ASTLM)
      JPI_ITEM(007)=%LOC(JPI$_AUTHPRIV)
      JPI_ITEM(008)=%LOC(JPI$_BIOCNT)
      JPI_ITEM(009)=%LOC(JPI$_BIOLM)
      JPI_ITEM(010)=%LOC(JPI$_BUFIO)
      JPI_ITEM(011)=%LOC(JPI$_BYTCNT)
      JPI_ITEM(012)=%LOC(JPI$_BYTLM)
      JPI_ITEM(013)=%LOC(JPI$_CPULIM)
      JPI_ITEM(014)=%LOC(JPI$_CPUTIM)
      JPI_ITEM(015)=%LOC(JPI$_CURPRIV)
      JPI_ITEM(016)=%LOC(JPI$_DFPFC)
      JPI_ITEM(017)=%LOC(JPI$_DFWSCNT)
      JPI_ITEM(018)=%LOC(JPI$_DIOCNT)
      JPI_ITEM(019)=%LOC(JPI$_DIOLM)
      JPI_ITEM(020)=%LOC(JPI$_DIRIO)
      JPI_ITEM(021)=%LOC(JPI$_EFCS)
      JPI_ITEM(022)=%LOC(JPI$_EFCU)
      JPI_ITEM(023)=%LOC(JPI$_EFWM)
      JPI_ITEM(024)=%LOC(JPI$_EXCVEC)
      JPI_ITEM(025)=%LOC(JPI$_FILCNT)
      JPI_ITEM(026)=%LOC(JPI$_FILLM)
      JPI_ITEM(027)=%LOC(JPI$_FINALEXC)
      JPI_ITEM(028)=%LOC(JPI$_FREP0VA)
      JPI_ITEM(029)=%LOC(JPI$_FREP1VA)
      JPI_ITEM(030)=%LOC(JPI$_GPGCNT)
      JPI_ITEM(031)=%LOC(JPI$_GRP)
      JPI_ITEM(032)=%LOC(JPI$_IMAGNAME)
      JPI_ITEM(033)=%LOC(JPI$_IMAGPRIV)
      JPI_ITEM(034)=%LOC(JPI$_LOGINTIM)
      JPI_ITEM(035)=%LOC(JPI$_MEM)
      JPI_ITEM(036)=%LOC(JPI$_OWNER)
      JPI_ITEM(037)=%LOC(JPI$_PAGEFLTS)
      JPI_ITEM(038)=%LOC(JPI$_PGFLQUOTA)
      JPI_ITEM(039)=%LOC(JPI$_PID)
      JPI_ITEM(040)=%LOC(JPI$_PPGCNT)
      JPI_ITEM(041)=%LOC(JPI$_PRCCNT)
      JPI_ITEM(042)=%LOC(JPI$_PRCLM)
      JPI_ITEM(043)=%LOC(JPI$_PRCNAM)
      JPI_ITEM(044)=%LOC(JPI$_PRI)
      JPI_ITEM(045)=%LOC(JPI$_PRIB)
      JPI_ITEM(046)=%LOC(JPI$_PROCPRIV)
      JPI_ITEM(047)=%LOC(JPI$_STATE)
      JPI_ITEM(048)=%LOC(JPI$_STS)
      JPI_ITEM(049)=%LOC(JPI$_TERMINAL)
      JPI_ITEM(050)=%LOC(JPI$_TMBU)
      JPI_ITEM(051)=%LOC(JPI$_TQCNT)
      JPI_ITEM(052)=%LOC(JPI$_TQLM)
      JPI_ITEM(053)=%LOC(JPI$_UIC)
      JPI_ITEM(054)=%LOC(JPI$_USERNAME)
      JPI_ITEM(055)=%LOC(JPI$_VIRTPEAK)
      JPI_ITEM(056)=%LOC(JPI$_VOLUMES)
      JPI_ITEM(057)=%LOC(JPI$_WSAUTH)
      JPI_ITEM(058)=%LOC(JPI$_WSPEAK)
      JPI_ITEM(059)=%LOC(JPI$_WSQUOTA)
      JPI_ITEM(060)=%LOC(JPI$_WSSIZE)
C----------------------------------------------------------------------*
C                                                                      *
C     INITIALIZE THE ACTUAL DISPLAY QUEUE                              *
C                                                                      *
C----------------------------------------------------------------------*
C     INITIALIZE INDIVIDUAL MEMBERS OF THE DISPLAY                     *
C----------------------------------------------------------------------*
      JPI_PAGE(001)=%LOC(JPI$_PRCNAM)
      JPI_PAGE(002)=%LOC(JPI$_PID)
      JPI_PAGE(003)=%LOC(JPI$_OWNER)
      JPI_PAGE(004)=%LOC(JPI$_USERNAME)
      JPI_PAGE(005)=%LOC(JPI$_ACCOUNT)
      JPI_PAGE(006)=%LOC(JPI$_UIC)
      JPI_PAGE(007)=%LOC(JPI$_GRP)
      JPI_PAGE(008)=%LOC(JPI$_MEM)
      JPI_PAGE(009)=%LOC(JPI$_PRI)
      JPI_PAGE(010)=%LOC(JPI$_PRIB)
      JPI_PAGE(011)=%LOC(JPI$_STATE)
      JPI_PAGE(012)=%LOC(JPI$_STS)
      JPI_PAGE(013)=%LOC(JPI$_EFCS)
      JPI_PAGE(014)=%LOC(JPI$_EFCU)
      JPI_PAGE(015)=%LOC(JPI$_EFWM)
      JPI_PAGE(016)=%LOC(JPI$_TERMINAL)
      JPI_PAGE(017)=%LOC(JPI$_LOGINTIM)
      JPI_PAGE(018)=%LOC(JPI$_IMAGNAME)
      JPI_PAGE(019)=%LOC(JPI$_AUTHPRIV)
      JPI_PAGE(020)=%LOC(JPI$_IMAGPRIV)
      JPI_PAGE(021)=%LOC(JPI$_PROCPRIV)
      JPI_PAGE(022)=%LOC(JPI$_CURPRIV)
      JPI_PAGE(023)=%LOC(JPI$_EXCVEC)
      JPI_PAGE(024)=%LOC(JPI$_FINALEXC)
      JPI_PAGE(025)=%LOC(JPI$_ASTACT)
      JPI_PAGE(026)=%LOC(JPI$_TMBU)
      JPI_PAGE(027)=%LOC(JPI$_ASTCNT)
      JPI_PAGE(028)=%LOC(JPI$_ASTEN)
      JPI_PAGE(029)=%LOC(JPI$_ASTLM)
      JPI_PAGE(030)=%LOC(JPI$_BIOCNT)
      JPI_PAGE(031)=%LOC(JPI$_BIOLM)
      JPI_PAGE(032)=%LOC(JPI$_BUFIO)
      JPI_PAGE(033)=%LOC(JPI$_BYTCNT)
      JPI_PAGE(034)=%LOC(JPI$_BYTLM)
      JPI_PAGE(035)=%LOC(JPI$_CPULIM)
      JPI_PAGE(036)=%LOC(JPI$_CPUTIM)
      JPI_PAGE(037)=%LOC(JPI$_DIOCNT)
      JPI_PAGE(038)=%LOC(JPI$_DIOLM)
      JPI_PAGE(039)=%LOC(JPI$_DIRIO)
      JPI_PAGE(040)=%LOC(JPI$_FILCNT)
      JPI_PAGE(041)=%LOC(JPI$_FILLM)
      JPI_PAGE(042)=%LOC(JPI$_VOLUMES)
      JPI_PAGE(043)=%LOC(JPI$_PAGEFLTS)
      JPI_PAGE(044)=%LOC(JPI$_PGFLQUOTA)
      JPI_PAGE(045)=%LOC(JPI$_DFPFC)
      JPI_PAGE(046)=%LOC(JPI$_APTCNT)
      JPI_PAGE(047)=%LOC(JPI$_PRCCNT)
      JPI_PAGE(048)=%LOC(JPI$_PRCLM)
      JPI_PAGE(049)=%LOC(JPI$_TQCNT)
      JPI_PAGE(050)=%LOC(JPI$_TQLM)
      JPI_PAGE(051)=%LOC(JPI$_VIRTPEAK)
      JPI_PAGE(052)=%LOC(JPI$_FREP0VA)
      JPI_PAGE(053)=%LOC(JPI$_FREP1VA)
      JPI_PAGE(054)=%LOC(JPI$_WSAUTH)
      JPI_PAGE(055)=%LOC(JPI$_DFWSCNT)
      JPI_PAGE(056)=%LOC(JPI$_WSPEAK)
      JPI_PAGE(057)=%LOC(JPI$_WSQUOTA)
      JPI_PAGE(058)=%LOC(JPI$_WSSIZE)
      JPI_PAGE(059)=%LOC(JPI$_PPGCNT)
      JPI_PAGE(060)=%LOC(JPI$_GPGCNT)
C----------------------------------------------------------------------*
C                                                                      *
C     INITIALIZE PROCESS CONTROL BLOCK PROCESS STATUS FLAGS            *
C                                                                      *
C----------------------------------------------------------------------*
      PCB_ITEM(001)=%LOC(PCB$V_ASTPEN)
      PCB_ITEM(002)=%LOC(PCB$V_BATCH)
      PCB_ITEM(003)=%LOC(PCB$V_DELPEN)
      PCB_ITEM(004)=%LOC(PCB$V_FORCPEN)
      PCB_ITEM(005)=%LOC(PCB$V_HIBER)
      PCB_ITEM(006)=%LOC(PCB$V_INQUAN)
      PCB_ITEM(007)=%LOC(PCB$V_LOGIN)
      PCB_ITEM(008)=%LOC(PCB$V_NETWRK)
      PCB_ITEM(009)=%LOC(PCB$V_NOACNT)
      PCB_ITEM(010)=%LOC(PCB$V_NODELET)
      PCB_ITEM(011)=%LOC(PCB$V_PHDRES)
      PCB_ITEM(012)=%LOC(PCB$V_PSWAPM)
      PCB_ITEM(013)=%LOC(PCB$V_PWRAST)
      PCB_ITEM(014)=%LOC(PCB$V_RES)
      PCB_ITEM(015)=%LOC(PCB$V_RESPEN)
      PCB_ITEM(016)=%LOC(PCB$V_SSFEXC)
      PCB_ITEM(017)=%LOC(PCB$V_SSFEXCE)
      PCB_ITEM(018)=%LOC(PCB$V_SSFEXCS)
      PCB_ITEM(019)=%LOC(PCB$V_SSFEXCU)
      PCB_ITEM(020)=%LOC(PCB$V_SSRWAIT)
      PCB_ITEM(021)=%LOC(PCB$V_SUSPEN)
      PCB_ITEM(022)=%LOC(PCB$V_SWPVBN)
      PCB_ITEM(023)=%LOC(PCB$V_WAKEPEN)
      PCB_ITEM(024)=%LOC(PCB$V_WALL)
C----------------------------------------------------------------------*
C                                                                      *
C     INITIALIZE PROCESS PRIVILEGE BIT MASKS                           *
C                                                                      *
C----------------------------------------------------------------------*
      PRV_ITEM(001)=%LOC(PRV$V_ALLSPOOL)
      PRV_ITEM(002)=%LOC(PRV$V_BUGCHK)
      PRV_ITEM(003)=%LOC(PRV$V_BYPASS)
      PRV_ITEM(004)=%LOC(PRV$V_CMEXEC)
      PRV_ITEM(005)=%LOC(PRV$V_CMKRNL)
      PRV_ITEM(006)=%LOC(PRV$V_DETACH)
      PRV_ITEM(007)=%LOC(PRV$V_DIAGNOSE)
      PRV_ITEM(008)=%LOC(PRV$V_EXQUOTA)
      PRV_ITEM(009)=%LOC(PRV$V_GROUP)
      PRV_ITEM(010)=%LOC(PRV$V_GRPNAM)
      PRV_ITEM(011)=%LOC(PRV$V_LOG_IO)
      PRV_ITEM(012)=%LOC(PRV$V_MOUNT)
      PRV_ITEM(013)=%LOC(PRV$V_NETMBX)
      PRV_ITEM(014)=%LOC(PRV$V_NOACNT)
      PRV_ITEM(015)=%LOC(PRV$V_OPER)
      PRV_ITEM(016)=%LOC(PRV$V_PFNMAP)
      PRV_ITEM(017)=%LOC(PRV$V_PHY_IO)
      PRV_ITEM(018)=%LOC(PRV$V_PRMCEB)
      PRV_ITEM(019)=%LOC(PRV$V_PRMGBL)
      PRV_ITEM(020)=%LOC(PRV$V_PRMMBX)
      PRV_ITEM(021)=%LOC(PRV$V_PSWAPM)
      PRV_ITEM(022)=%LOC(PRV$V_SETPRI)
      PRV_ITEM(023)=%LOC(PRV$V_SETPRV)
      PRV_ITEM(024)=%LOC(PRV$V_SHMEM)
      PRV_ITEM(025)=%LOC(PRV$V_SYSGBL)
      PRV_ITEM(026)=%LOC(PRV$V_SYSNAM)
      PRV_ITEM(027)=%LOC(PRV$V_SYSPRV)
      PRV_ITEM(028)=%LOC(PRV$V_TMPMBX)
      PRV_ITEM(029)=%LOC(PRV$V_VOLPRO)
      PRV_ITEM(030)=%LOC(PRV$V_WORLD)
C----------------------------------------------------------------------*
C                                                                      *
C     INITIALIZE PROCESS STATE IDENTIFIERS                             *
C                                                                      *
C----------------------------------------------------------------------*
      SCH_ITEM(001)=%LOC(SCH$C_CEF)
      SCH_ITEM(002)=%LOC(SCH$C_COLPG)
      SCH_ITEM(003)=%LOC(SCH$C_COM)
      SCH_ITEM(004)=%LOC(SCH$C_COMO)
      SCH_ITEM(005)=%LOC(SCH$C_CUR)
      SCH_ITEM(006)=%LOC(SCH$C_FPG)
      SCH_ITEM(007)=%LOC(SCH$C_HIB)
      SCH_ITEM(008)=%LOC(SCH$C_HIBO)
      SCH_ITEM(009)=%LOC(SCH$C_LEF)
      SCH_ITEM(010)=%LOC(SCH$C_LEFO)
      SCH_ITEM(011)=%LOC(SCH$C_MWAIT)
      SCH_ITEM(012)=%LOC(SCH$C_PFW)
      SCH_ITEM(013)=%LOC(SCH$C_SUSP)
      SCH_ITEM(014)=%LOC(SCH$C_SUSPO)
C----------------------------------------------------------------------*
C     SECTION 200                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C     INITIALIZE TERMINAL INTERFACE AND REQUEST PROCESS NAME           *
C                                                                      *
C----------------------------------------------------------------------*
  200 CONTINUE
      STATUS=LIB$GET_FOREIGN(PROCESS,'Enter Process Name: ',LIM)
      IF (STATUS .NE. %LOC(SS$_NORMAL)) GO TO 800
      IF (LIM .EQ. ZERO) GO TO 200
      CALL DELETE_CONTROL(PROCESS)
      LIM=LENGTH(PROCESS)
C----------------------------------------------------------------------*
C                                                                      *
C     PERFORM PROCESS WILDCARD SEARCH AND TRY TO MATCH PROCESS NAME    *
C     WITH THAT SPECIFIED BY THE USER.  ASSUME USER PROCESS NAME.      *
C                                                                      *
C----------------------------------------------------------------------*
      PID_SEARCH=WILDCARD

  210 CONTINUE
      STATUS=SYS$JPI(PID_SEARCH,,%LOC(JPI$_PID),PID,)
      IF (STATUS .EQ. %LOC(SS$_NOMOREPROC)) GO TO 230
      STATUS=SYS$JPI(PID,,%LOC(JPI$_PRCNAM),OUTPUT,)
      CALL DELETE_CONTROL(OUTPUT)
      LIMIT=LENGTH(OUTPUT)
      IF (LIM .NE. LIMIT) GO TO 210
      IF (PROCESS(ONE:LIM) .NE. OUTPUT(ONE:LIM)) GO TO 210

      GO TO 300
C----------------------------------------------------------------------*
C                                                                      *
C     ASSUME USER ENTERED PROCESS ID (HEX) RATHER THAN PROCESS NAME    *
C                                                                      *
C----------------------------------------------------------------------*
  230 CONTINUE
      CALL DECODE_HEXDEC(PROCESS,PID,NODATA,ERROR)
      STATUS=%LOC(SS$_NONEXPR)
      IF (NODATA .OR. ERROR) GO TO 800

      STATUS=SYS$JPI(PID,,%LOC(JPI$_PRCNAM),OUTPUT,)
      IF (STATUS .NE. %LOC(SS$_NORMAL)) GO TO 800
C----------------------------------------------------------------------*
C     SECTION 300                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C     DISPLAY JOB PROCESS INFORMATION ON USER SPECIFIED PROCESS        *
C                                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C     DETERMINE ITEM WHICH IS TO BE DISPLAYED                          *
C                                                                      *
C----------------------------------------------------------------------*
  300 CONTINUE

      DO 720 USRJPI=ONE,MAXJPI
      OUTPUT=BLANK
      DISPLAY=JPI_PAGE(USRJPI)
C----------------------------------------------------------------------*
C                                                                      *
C     SEARCH FOR ITEM IN LIST OF VALID JOB PROCESS ITEMS               *
C                                                                      *
C----------------------------------------------------------------------*
      DO POINTER=ONE,MAXJPI
           JPIPTR=POINTER
           IF (DISPLAY .EQ. JPI_ITEM(POINTER)) GO TO 400
      ENDDO
     
      GO TO 720
C----------------------------------------------------------------------*
C     SECTION 400                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C     REQUEST JOB PROCESS INFORMATION                                  *
C                                                                      *
C----------------------------------------------------------------------*
  400 CONTINUE
      JPITYP=JPI_TYPE(JPIPTR)
      
      IF (JPITYP .EQ. STRING) THEN
           STATUS=SYS$JPI(PID,,DISPLAY,JPI_STRING,LIM)
      ELSE
           STATUS=SYS$JPI(PID,,DISPLAY,JPI_VALUE,LIM)
      ENDIF

      IF (STATUS .EQ. %LOC(SS$_NORMAL)) GO TO 500
      CALL SYS$GETMSG(%VAL(STATUS),LIM,OUTPUT,%VAL(FULL),)
      GO TO 710
C----------------------------------------------------------------------*
C     SECTION 500                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C     PROCESS NUMERIC DISPLAYS                                         *
C                                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C     PROCESS BYTE HEX DISPLAYS                                        *
C                                                                      *
C----------------------------------------------------------------------*
  500 CONTINUE
      IF (JPITYP .NE. BYTEHEX) GO TO 510
      CALL HEXFMT(JPI_VALUE,OUTPUT,TWO)
      GO TO 700
C----------------------------------------------------------------------*
C                                                                      *
C     PROCESS BYTE OCTAL DISPLAYS                                      *
C                                                                      *
C----------------------------------------------------------------------*
  510 CONTINUE
      IF (JPITYP .NE. BYTEOCT) GO TO 520
      CALL OCTFMT(JPI_VALUE,OUTPUT,THREE)
      GO TO 700
C----------------------------------------------------------------------*
C                                                                      *
C     PROCESS DECIMAL DISPLAYS                                         *
C                                                                      *
C----------------------------------------------------------------------*
  520 CONTINUE
      IF (JPITYP .NE. DECIMAL) GO TO 530
      CALL INTFMT(JPI_VALUE(ONE),OUTPUT,LIM)
      GO TO 710
C----------------------------------------------------------------------*
C                                                                      *
C     PROCESS LONGWORD HEX DISPLAYS                                    *
C                                                                      *
C----------------------------------------------------------------------*
  530 CONTINUE
      IF (JPITYP .NE. LONGHEX) GO TO 540
      CALL HEXFMT(JPI_VALUE(ONE),OUTPUT,EIGHT)
      GO TO 700
C----------------------------------------------------------------------*
C                                                                      *
C     PROCESS QUADWORD PRIVILEGE MASKS                                 *
C                                                                      *
C----------------------------------------------------------------------*
  540 CONTINUE
      IF (JPITYP .NE. PRIVMSK) GO TO 550

      DO POINTER=ONE,MAXPRV
           MASK=TWO**PRV_ITEM(POINTER)
           MASK=(MASK .AND. JPI_VALUE(ONE))
           IF (MASK .NE. ZERO)
     1          OUTPUT((LENGTH(OUTPUT)+ONE):)=COMMA//PRV_NAME(POINTER)
      ENDDO

      OUTPUT=OUTPUT(TWO:)
      GO TO 700
C----------------------------------------------------------------------*
C                                                                      *
C     PROCESS SPECIAL DISPLAYS                                         *
C                                                                      *
C----------------------------------------------------------------------*
C     PROCESS STATE DISPLAY                                            *
C----------------------------------------------------------------------*
  550 CONTINUE
      IF (JPITYP .NE. SPECIAL) GO TO 560

      IF (DISPLAY .EQ. %LOC(JPI$_STATE)) THEN


           DO POINTER=ONE,MAXSCH
                IF (JPI_VALUE(ONE) .EQ. SCH_ITEM(POINTER)) 
     1               OUTPUT=SCH_NAME(POINTER)
           ENDDO


      ELSE IF (DISPLAY .EQ. %LOC(JPI$_STS)) THEN


           DO POINTER=ONE,MAXPCB
                MASK=TWO**PCB_ITEM(POINTER)
                MASK=(MASK .AND. JPI_VALUE(ONE))
                IF (MASK .NE. ZERO) OUTPUT((LENGTH(OUTPUT)+ONE):)=
     1               COMMA//PCB_NAME(POINTER)
           ENDDO

           OUTPUT=OUTPUT(TWO:)


      ENDIF

      
      GO TO 700
C----------------------------------------------------------------------*
C                                                                      *
C     PROCESS CHARACTER STRING DISPLAYS                                *
C                                                                      *
C----------------------------------------------------------------------*
  560 CONTINUE
      IF (JPITYP .NE. STRING) GO TO 570
      OUTPUT=JPI_STRING
      CALL DELETE_CONTROL(OUTPUT)
      GO TO 700
C----------------------------------------------------------------------*
C                                                                      *
C     PROCESS SYSTEM TIME QUADWORD DISPLAYS                            *
C                                                                      *
C----------------------------------------------------------------------*
  570 CONTINUE
      IF (JPITYP .NE. SYSTIME) GO TO 580
      CALL SYS$ASCTIM(LIM,OUTPUT,JPI_VALUE,)
      GO TO 710
C----------------------------------------------------------------------*
C                                                                      *
C     PROCESS WORD HEX DISPLAYS                                        *
C                                                                      *
C----------------------------------------------------------------------*
  580 CONTINUE
      IF (JPITYP .NE. WORDHEX) GO TO 590
      CALL HEXFMT(JPI_VALUE,OUTPUT,FOUR)
      GO TO 700
C----------------------------------------------------------------------*
C                                                                      *
C     PROCESS WORD OCTAL DISPLAYS                                      *
C                                                                      *
C----------------------------------------------------------------------*
  590 CONTINUE
      IF (JPITYP .NE. WORDOCT) GO TO 720
      CALL OCTFMT(JPI_VALUE,OUTPUT,SIX)
C----------------------------------------------------------------------*
C     SECTION 700                                                      *
C----------------------------------------------------------------------*
C     DISPLAY JOB PROCESS VALUE TO USER                                *
C----------------------------------------------------------------------*
  700 CONTINUE
      LIM=LENGTH(OUTPUT)

  710 CONTINUE
      OUTPUT=LEFT//JPI_NAME(JPIPTR)(ONE:MAXNAM)//RIGHT//BLANK//BLANK//
     1     JPI_LABEL(JPIPTR)//'= '//OUTPUT(ONE:LIM)
      STATUS=LIB$PUT_OUTPUT(OUTPUT(ONE:LENGTH(OUTPUT)))
C----------------------------------------------------------------------*
C     SECTION 720                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C     END OF MAIN PROCESSING LOOP                                      *
C                                                                      *
C----------------------------------------------------------------------*
  720 CONTINUE
      GO TO 900
C----------------------------------------------------------------------*
C     SECTION 800                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C     ERROR PROCESSING                                                 *
C                                                                      *
C----------------------------------------------------------------------*
C     VAX/VMS ERROR REPORTS                                            *
C----------------------------------------------------------------------*
  800 CONTINUE
      CALL SYS$GETMSG(%VAL(STATUS),LIM,OUTPUT,%VAL(FULL),)
      STATUS=LIB$PUT_OUTPUT(OUTPUT(ONE:LIM))
C----------------------------------------------------------------------*
C     SECTION 900                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C     PROGRAM TERMINATION                                              *
C                                                                      *
C----------------------------------------------------------------------*
  900 CONTINUE
C----------------------------------------------------------------------*
C     END OF PROGRAM GETJPI                                            *
C----------------------------------------------------------------------*
      END

