c PROGRAM ETAPE
c
c This program manipulates foreign tapes (at present only in EBCDIC
c format). It allows the user to look at any file or block on the tape,
c to move around anywhere in the tape, and to translate the data and
c put it in a disk file(s). EBCDIC translation may be turned off.
c
c Version 1.0
c Date:	04-feb-1982
c	17-Feb-1982	toggle EBCDIC mode (UT function) added
c	24-May-1982	write capability (WR & TM functions) added
c
	include 'ssdef.ftn/nolist'  ! $ssdef definitions parameterized
	include 'iodef.ftn/nolist'  ! $iodef definitions parameterized
	include 'lbrdef.ftn/nolist' ! $lbrdef definitions parameterized
c
	parameter MAXBLOCK=16000  ! maximum blocksize; may be changed
c
	integer SYS$ASSIGN,SYS$QIOW,STR$UPCASE  ! system calls
	integer*2 channel,iosb(4),status,count  ! system call parameters
	equivalence (status,iosb(1)),(count,iosb(2))
	integer ttyin,ttyout,fileout,filein,num,lrecl,bf,retcode,ios
	integer blocksize,block,file,nout,devtype,oblk
	logical at_end,at_begin,to_tty,lib_open,incr_block,ebcdic
	character buffer*16000,record*16000	! should match MAXBLOCK
	character req*2,rest*40,toupper*2,sysmsg*80,c2*2,filename*33
	integer*2 msglen,line_width,lpp
	byte ttype
	common/terminal/ttyin,ttyout,line_width,lpp
c
	data ttyin,ttyout,fileout,filein/5,6,1,2/
c
c setup
c
	at_begin=.true.	! we start at the appropriate end of the tape
	at_end=.false.	! and not here
	file=1		! positioning information
	block=1
	blocksize=MAXBLOCK	! until told otherwise
	lrecl=80	! most common value
	bf=blocksize/lrecl	! blocking factor
	to_tty=.true.	! initially, all output to terminal
	nout=0		! number of records written
	call LIB$SCREEN_INFO(ttype,devtype,line_width,lpp) ! get terminal info
	lib_open=.false.	! for help functions
	ebcdic=.true.	! will translate until told otherwise
c
c assign channel for tape, then rewind it
c
	retcode=SYS$ASSIGN('TAPE',channel,,)	! uses logical name 'tape:'
	if(retcode.ne.SS$_NORMAL)goto 9000
	retcode=SYS$QIOW(,%val(channel),%val(IO$_REWIND),iosb,,,,,,,,)
	if(retcode.ne.SS$_NORMAL)goto 9010
c
c begin of main loop. read a request from the current input and branch
c depending on what user wants.
c
100	write(ttyout,1)
	read(ttyin,2,err=9020,end=2400)c2,rest
	if(STR$UPCASE(req,c2).ne.SS$_NORMAL)goto 9020
	if(req.eq.'BB')goto 400
	if(req.eq.'BF')goto 800
	if(req.eq.'BL')goto 2200
	if(req.eq.'FI')goto 1200
	if(req.eq.'HE')goto 1600
	if(req.eq.'LR')goto 2000
	if(req.eq.'QU')goto 2400
	if(req.eq.'RW')goto 2800
	if(req.eq.'SB')goto 3200
	if(req.eq.'SF')goto 3600
	if(req.eq.'UT')goto 4800
	if(req.eq.'TB')goto 4000
	if(req.eq.'TF')goto 4400
	if(req.eq.'WH')goto 5200
	if(req.eq.'WR')goto 5600
	if(req.eq.'TM')goto 5800
	goto 9020	! undefined response
c
c backspace tape specified number of blocks
c this will not backspace past a tape mark, or from end of tape
c
400	if(at_end.or.at_begin)goto 9060
	read(rest,3,IOSTAT=ios,err=9030)num
	num=max(1,num)
	retcode=SYS$QIOW(,%val(channel),%val(IO$_SKIPRECORD),iosb,,,
	4%val(-num),,,,,)
c
c check completion status
c
	if(retcode.ne.SS$_NORMAL)goto 9040
	if(status.ne.SS$_NORMAL.and.status.ne.SS$_ENDOFTAPE.and.
	4status.ne.SS$_ENDOFFILE)goto 9050
c
c if end_of_file condition, then step the controller forward past the
c tape mark we just skipped, so we are positioned at the same file
c we started at. this is not necessary if end_of_tape condition is
c encountered; here we assume we have just done a rewind
c
	if(status.eq.SS$_ENDOFTAPE)then
		at_begin=.true.
		file=1
		block=1
	elseif(status.eq.SS$_ENDOFFILE)then
		num=1
		incr_file=.false.	! we aren't really skipping a file
		goto 3300  ! branch to skip forward routine
	else
		block=max(block-count,1)
	endif
	at_end=.false.
	goto 8900
c
c backspace specified number of files. No action if at beginning of tape,
c otherwise position at beginning of last file backspaced over. Note that
c if you backspace 1 file, this puts you at the beginning of the current
c file, not at the previous file.
c
800	if(at_begin)goto 9060	! can't go back any further
	read(rest,3,IOSTAT=ios,err=9030)num
	num=max(1,num)
	retcode=SYS$QIOW(,%val(channel),%val(IO$_SKIPFILE),iosb,,,
	4%val(-num),,,,,)
c
c check status
c
	if(retcode.ne.SS$_NORMAL)goto 9040
	if(status.eq.SS$_ENDOFTAPE)then
		file=1
		block=1
		at_begin=.true.
		at_end=.false.
		goto 8900
	endif
	if(status.ne.SS$_NORMAL)goto 9050
	file=max(file-count+1,1)
	num=1
	incr_file=.false.	! not really skipping files
	goto 3300  ! to advance past tape mark
c
c read a file name and open it. First close any other file that is
c open on unit fileout. If no parameter specified, or error occurs,
c send output to tty.
c
1200	if(.not.to_tty)close(fileout)
	if(rest.eq.' ')then
		to_tty=.true.
	else
		filename=rest
		open(unit=fileout,name=filename,carriagecontrol='LIST',
	4	organization='sequential',status='NEW',err=9070)
		to_tty=.false.
		nout=0
	endif
	goto 8900
c
c print help messages
c
1600	if(.not.lib_open)then	! open the help library
		retcode=LBR$INI_CONTROL(index,LBR$C_READ,,)
		if(.not.retcode)goto 9080
		retcode=LBR$OPEN(index,'SYS$HELP:HELPLIB.HLB',,,,,)
		if(.not.retcode)goto 9090
		lib_open=.true.
	endif
	if(rest.eq.' ')then	! general help requested
		status=LBR$GET_HELP(index,,,,'ETAPE')
	else
		status=LBR$GET_HELP(index,,,,'ETAPE',rest(1:2))
	endif
	if(.not.status)write(ttyout,4)
	goto 100
c
c specify logical record length. Need not be a multiple of blocksize.
c
2000	read(rest,3,IOSTAT=ios,err=9030)lrecl
	if(lrecl.gt.MAXBLOCK)then
		lrecl=80
		write(ttyout,8)MAXBLOCK,lrecl
	endif
	if(lrecl.le.0)then
		write(ttyout,6)
		lrecl=1
	endif
	goto 100
c
c specify blocksize.
c
2200	read(rest,3,IOSTAT=ios,err=9030)blocksize
	if(blocksize.gt.MAXBLOCK)then
		blocksize=MAXBLOCK
		write(ttyout,8)MAXBLOCK,lrecl
	endif
	if(blocksize.lt.18)then
		write(ttyout,5)
		blocksize=18
	endif
	if(lrecl.gt.blocksize)lrecl=blocksize	! that wouldn't do at all !
	goto 100
c
c Quit and unload the tape offline and close any open files
c
2400	if(.not.to_tty)close(fileout)
	retcode=SYS$QIOW(,%val(channel),%val(IO$_REWINDOFF.or.IO$M_NOWAIT)
	4,iosb,,,,,,,,)
	stop
c
c rewind tape, but don't unload
c
2800	retcode=SYS$QIOW(,%val(channel),%val(IO$_REWIND),iosb,,,,,,,,)
	if(retcode.ne.SS$_NORMAL)goto 9030
	file=1
	block=1
	at_begin=.true.
	at_end=.false.
	goto 8900
c
c skip blocks in forward direction. Stop at end of file or tape or volume
c and in that case, stay positioned at beginning of next file (if any).
c statement 3300 can also be reached from portions of code that do the
c backspacing, as backspacing can put you before a tapemark.
c
3200	if(at_end)goto 8900
	read(rest,3,IOSTAT=ios,err=9030)num
	num=max(1,num)
	incr_file=.true.
3300	retcode=SYS$QIOW(,%val(channel),%val(IO$_SKIPRECORD),iosb,,,
	4%val(num),,,,,)
c
c check status
c
	if(retcode.ne.SS$_NORMAL)goto 9040
	if(status.eq.SS$_ENDOFTAPE.or.status.eq.SS$_ENDOFVOLUME)then
		at_end=.true.
	elseif(status.eq.SS$_ENDOFFILE)then
		if(incr_file)file=file+1
		block=1
	elseif(status.ne.SS$_NORMAL)then
		goto 9050
	else
		block=block+count
	endif
	at_begin=.false.
	goto 8900
c
c skip files in a forward direction
c
3600	if(at_end)goto 8900
	read(rest,3,IOSTAT=ios,err=9030)num
	num=max(1,num)
	retcode=SYS$QIOW(,%val(channel),%val(IO$_SKIPFILE),iosb,,,
	4%val(num),,,,,)
c
c check status
c
	if(retcode.ne.SS$_NORMAL)goto 9040
	if(status.eq.SS$_ENDOFTAPE.or.status.eq.SS$_ENDOFVOLUME)then
		at_end=.true.
	elseif(status.ne.SS$_NORMAL.and.status.ne.SS$_ENDOFFILE)then
		goto 9050
	else
		file=file+count
		block=1
	endif
	at_begin=.false.
	goto 8900
c
c translate blocks. '*' inplies all remaining blocks in this file. Note
c that we go by tape blocks, not logical records as specified by lrecl.
c
4000	if(at_end)goto 8900
	if(rest.eq.'*')then
		num=32767
	else
		read(rest,3,IOSTAT=ios,err=9030)num
		num=max(1,num)
	endif
c
c loop on files
c
	do 4100 i=1,num
		retcode=SYS$QIOW(,%val(channel),%val(IO$_READLBLK),iosb,,,
	4	%ref(buffer(1:1)),%val(blocksize),,,,)
		if(retcode.ne.SS$_NORMAL)goto 9040
		if(status.eq.SS$_ENDOFTAPE.or.status.eq.SS$_ENDOFVOLUME)then
			at_end=.true.
			at_begin=.false.
			goto 8900
		elseif(status.eq.SS$_ENDOFFILE)then
			file=file+1
			block=1
			at_begin=.false.
			goto 8900
		elseif(status.eq.SS$_DATAOVERUN)then
			write(ttyout,7)block,count
		elseif(status.ne.SS$_NORMAL)then
			goto 9050
		elseif(count.lt.blocksize)then
			write(ttyout,9)count,block
		endif
		block=block+1
		at_begin=.false.
c
c translate, deblock and write the output
c
		call translate(buffer,count,ebcdic)
		call deblock(buffer,count,lrecl,fileout,to_tty,nout)
4100	continue
	goto 8900
c
c translate consecutive files and merge to output
c
4400	if(at_end)goto 8900
	if(rest.eq.'*')then
		num=32767
	else
		read(rest,3,IOSTAT=ios,err=9030)num
		num=max(1,num)
	endif
c
c loop on files
c
	do 4700 i=1,num
4600		retcode=SYS$QIOW(,%val(channel),%val(IO$_READLBLK),iosb,,,
	4	%ref(buffer(1:1)),%val(blocksize),,,,)
		if(retcode.ne.SS$_NORMAL)goto 9040
		if(status.eq.SS$_ENDOFFILE)then
			write(ttyout,10)file
			file=file+1
			block=1
			at_begin=.false.
			goto 4700
		elseif(status.eq.SS$_ENDOFTAPE.or.status.eq.SS$_ENDOFVOLUME)then
			write(ttyout,11)
			at_end=.true.
			at_begin=.false.
			goto 8900
		elseif(status.eq.SS$_DATAOVERUN)then
			write(ttyout,7)block
		elseif(status.ne.SS$_NORMAL)then
			goto 9050
		elseif(count.lt.blocksize)then
			write(ttyout,9)count,block
		endif
		block=block+1
		at_begin=.false.
		call translate(buffer,count,ebcdic)
		call deblock(buffer,count,lrecl,fileout,to_tty,nout)
		goto 4600
4700	continue
	goto 8900
c
c change translation (invert)
c
4800	ebcdic=.not.ebcdic
	goto 100
c
c print detailed statistics
c
5200	write(ttyout,16)file,block
	if(to_tty)then
		write(ttyout,17)
	else
		write(ttyout,18)filename,nout
	endif
	write(ttyout,19)blocksize,lrecl
	if(ebcdic)then
		write(ttyout,24)'ON'
	else
		write(ttyout,24)'OFF'
	endif
	goto 8900
c
c Write a file to tape. Block the records according to the current values
c of lrecl and blocksize. Translate to ebcdic if desired.
c
5600	filename=rest
	open(unit=filein,name=filename,status='OLD',err=9070,
	4	access='SEQUENTIAL',iostat=icode,readonly)
	iread=0	! count of records read from file
	oblk=0	! count of tape blocks written
	irec=0	! count of records in this block
5700	read(filein,25,end=5750,err=9110)nc,record(1:nc)
	irec=irec+1
	iread=iread+1
	if(nc.lt.lrecl)then	! pad record with blanks
		record(nc+1:lrecl)=' '
	elseif(nc.gt.lrecl)then	! truncate record & print message
		write(ttyout,26)iread,lrecl
	endif
c
c Check if this record will fit in current block. If it won't, then
c output the current block to the tape.
c
	if(irec*lrecl.gt.blocksize)then		! it won't fit
		call untranslate(buffer,(irec-1)*lrecl,ebcdic)
		retcode=SYS$QIOW(,%val(channel),%val(IO$_WRITELBLK),iosb,,,
	4		%ref(buffer(1:1)),%val((irec-1)*lrecl),,,,)
		if(retcode.ne.SS$_NORMAL)goto 9040
		oblk=oblk+1
		irec=1
	endif
c
c Add this record to the current block.
c
	ib=(irec-1)*lrecl+1
	ie=ib+lrecl-1
	buffer(ib:ie)=record(1:lrecl)
	goto 5700
c
c At end of input file, may have to output partial block.
c
5750	call untranslate(buffer,irec*lrecl,ebcdic)
	retcode=SYS$QIOW(,%val(channel),%val(IO$WRITELBLK),iosb,,,
	4	%ref(buffer(1:1)),%val(irec*lrecl),,,,)
	if(retcode.ne.SS$_NORMAL)goto 9040
	oblk=oblk+1
	write(ttyout,27)iread,oblk
	close(filein)
c
c Also the entry point for writing a tape mark.
c
5800	retcode=SYS$QIOW(,%val(channel),%val(IO$_WRITEOF),iosb,,,,,,,,)
	if(retcode.ne.SS$_NORMAL)goto 9100
	block=1
	at_end=.true.
	file=file+1
	goto 8900
c
c update position and display it in the form:
c fff:bbbb ==> [tty | filename (nout)]
c fff is current file number, bbbb is block number ("AT_END" displayed if
c at end of tape). TTY displayed if output to tty, otherwise the output
c filename and the number of records written to it are displayed.
c
8900	if(at_end.and.to_tty)then
		write(ttyout,20)
	elseif(at_end.and..not.to_tty)then
		write(ttyout,21)filename,nout
	elseif(.not.at_end.and.to_tty)then
		write(ttyout,22)file,block
	else
		write(ttyout,23)file,block,filename,nout
	endif
	goto 100
c
c errors
c
9000	write(ttyout,9901)
9901	format(' Can''t assign channel for tape')
	goto 9040
9010	write(ttyout,9902)
9902	format(' Can''t rewind tape')
	stop
9020	write(ttyout,9903)req
9903	format(' Request <',a,'> not understood. Type HE for help')
	goto 100
9030	write(ttyout,9904)ios,rest
9904	format(' Parameter invalid:',i3,' <',a,'>')
	goto 100
9040	write(ttyout,9905)retcode
9905	format(' SYS$QIOW returned error code:',z8)
9045	call SYS$GETMSG(%val(retcode),msglen,sysmsg,,)
	write(ttyout,13)sysmsg(1:msglen)
	goto 9500
9050	write(ttyout,9906)status
9906	format(' SYS$QIOW illegal status:',z8)
	call SYS$GETMSG(%val(status),msglen,sysmsg,,)
	write(ttyout,13)sysmsg(1:msglen)
	goto 9500
9060	write(ttyout,9907)
9907	format(' Illegal operation at beginning or end of tape')
	goto 100
9070	write(ttyout,9908)filename
9908	format(' Error opening file:',a)
	to_tty=.true.
	goto 8900
9080	write(ttyout,9909)retcode
9909	format(' Help error:',z8)
	goto 9095
9090	write(ttyout,9909)retcode
9095	call SYS$GETMSG(%val(retcode),msglen,sysmsg,,)
	write(ttyout,13)sysmsg(1:msglen)
	goto 100
9100	write(ttyout,9910)
9910	format(' Error writing tapemark')
	goto 9045
9110	write(ttyout,9911)icode
9911	format(' Read error on file ',i)
	goto 5750
c
c common fatal error handler. rewind tape; if successful, he can continue,
c otherwise we might as well stop
c
9500	retcode=SYS$QIOW(,%val(channel),%val(IO$_REWIND),iosb,,,,,,,,)
	if(retcode.ne.SS$_NORMAL)then
		write(ttyout,14)
		if(.not.to_tty)close(fileout)
		stop
	else
		write(ttyout,15)
		at_begin=.true.
		at_end=.false.
		file=1
		block=1
		goto 8900
	endif
c
c format statements
c
1	format(' ETAPE>',$)
2	format(a2,1x,a)
3	format(bn,i8)
4	format(' Help not available on that topic')
5	format(' Minimum blocksize is 18 bytes')
6	format(' Record length set to minimum of 1')
7	format(' Block ',i,' truncated from length 'i)
8	format(' Max blocksize is',i,' default lrecl is',i)
9	format(' Short block of ',i,' read for block number ',i)
10	format(' End of file ',i)
11	format(' End of tape reached')
12	format(' This feature not yet implemented')
13	format(1x,a)
14	format(' Fatal error, must stop')
15	format(' Tape rewound...')
16	format(' Tape positioned at file number ',i,' block ',i)
17	format(' Output currently going to TTY')
18	format(' Output currently going to file ',a/1x,i,' blocks written')
19	format(' Blocksize is set at ',i,' and record length is ',i)
20	format(' AT_END     ==> TTY')
21	format(' AT_END     ==> ',a,' (',i,')')
22	format(1x,i3.3,':',i4.4,' ==> TTY')
23	format(1x,i3.3,':',i4.4,' ==> ',a,' (',i,')')
24	format(' EBCDIC translation is turned ',a3)
25	format(q,a)
26	format(' Input record # ',i,' truncated to len ',i6)
27	format(i,' records read from file: ',i,' blocks written to tape')
c
	end
c
c subroutine package for use with ETAPE program. includes the following:
c	deblock - breaks logical tape blocks into records
c	translate - translate from ebcdic to ascii
c	untranslate - translate from ascii to ebcdic
c	out_tty - outputs tape record to terminal
c	out_file - outputs tape record to file
c	strip - removes trailing blanks from record
c
	subroutine deblock(buffer,count,lrecl,fileout,to_tty,nout)
	character buffer*(*)		! input tape block to deblock
	integer*2 count			! # characters in buffer
	integer lrecl			! logical record length
	integer fileout			! unit to write to
	logical to_tty			! true if output is to go to tty
	integer nout			! count of records written to file
	integer rec			! record number written to tty
	integer*2 newcount		! after stripping blanks

c
	rec=0
	do 100 i=1,count,lrecl
		kl=min(i+lrecl-1,count)
		rec=rec+1
		if(to_tty)then
			call out_tty(buffer(i:kl),rec)
		else
			call out_file(buffer(i:kl),fileout)
			nout=nout+1
		endif
100	continue
c
	return
	end
c
c
	subroutine translate(buffer,count,ebcdic)
	character buffer*(*)		! contains one logical tape block
	integer*2 count			! # characters in buffer
	logical ebcdic
c
	if(ebcdic)call LIB$TRA_EBC_ASC(buffer(1:count),buffer(1:count))
c
	return
	end
c
c
	subroutine untranslate(buffer,count,ebcdic)
	character buffer*(*)		! contains one logical tape block
	integer*2 count			! # characters in buffer
	logical ebcdic
c
	if(ebcdic)call LIB$TRA_ASC_EBC(buffer(1:count),buffer(1:count))
c
	return
	end
c
c
	subroutine out_tty(buffer,rec)
	character buffer*(*)		! buffer to print (1 record)
	integer rec			! record number within block
	integer oline,lines_per_page,ttyin,ttyout
	integer*2 line_width,lpp,length,newlen
	common/terminal/ttyin,ttyout,line_width,lpp
	character junk*1
c
c format neatly for terminal using information in common block about
c page width and length (assume length of 0 or > 25 means hard copy terminal)
c
	length=len(buffer)
	call strip(buffer,length,newlen)
	length=newlen
	oline=line_width-8	! characters available for output
	lines_per_record=(length+oline-1)/oline
c
c check if this record will overflow screen
c
	if(lpp.le.25.and.lpp.gt.0.and.lines_per_page*(rec-1).gt.lpp)then
		write(ttyout,1)
		read(ttyin,2)junk
	endif
c
c output the record
c
	do 100 i=1,length,oline
		kl=min(i+oline-1,length)
		if(i.eq.1)then
			write(ttyout,3)rec,buffer(i:kl)
		else
			write(ttyout,2)buffer(i:kl)
		endif
100	continue
c
	return
1	format(' Press return for more ==>',$)
2	format(t8,a)
3	format(1x,i4.4,':	',a)
	end
c
c
	subroutine out_file(buffer,unit)
	character buffer*(*)		! output record (deblocked & translated)
	integer unit			! where to write it
	integer len,newlen
c
	length=len(buffer)
	call strip(buffer,length,newlen)
	length=newlen
	write(unit,1)buffer(:newlen)
1	format(a)
	return
	end

c
c
	subroutine strip(buffer,count,newcount)
	character buffer*(*)
	integer*2 count,newcount
c
	do 100 i=count,1,-1
		if(buffer(i:i).ne.' ')goto 150
100	continue
	i=1
150	newcount=i
	return
	end
