
C  gpak -- simple FORTRAN-based graphics package for GIGI
C  March 1979
C  May   1980
C  July  1981
C  Feb	1982
C  R. J. Fleischer
C 
C 
C   			D I S C L A I M E R
C   
C    
C    
C   	The information in this software is subject to change  without 
C   	notice  and should not be construed as a commitment by Digital 
C   	Equipment Corporation. 
C    
C   	DIGITAL assumes no responsibility for the use  or  reliability 
C   	of this software.
C    
C 	This software is not supported by DIGITAL.
C 
C  operating-system-dependent switches
C ========== Ratfor character definitions ==========
C 	 9-FEB-79
C 	12-MAY-80
C 	28-AUG-81
C  ampersand
C  exclamation mark
C  ASCIZ strings as used by SYSLIB
C  max length of a file spec
C  max element count in packed char array
C  input record size
C  must be 2 more than MAXRECORD
C  alternative to YES, NO
C  a linefeed
C  for OPENF calls
C 	"
C 	"
C 	"
C  first char in FORMAT with LIST carriagecontrol
C  ascii numeric value corresponding to LISTSS, above
C  char i/o format:  "r1" for TOPS-20
C TOPS	define(CHARFORMAT,r1)	#	"a1" otherwise
C  quoted string version of above
C TOPS	define(CHARFORMATQ,'r1')
C  if "#", omit packed string code
C  5 for TOPS-20, 1 otherwise
C TOPS	define(PACKEDDENSITY,5)
C  on this machine, unpack == scopyl
C 	"	", pack == scopy
C TOPS	define(character,integer)
C  end of standard system defines
C =============================================================================

C  length of char representation of largest integer
C  one more than MAXINTLEN
C  length (in characters) of longest real number
C lun for locator-mode logging
C lun for reading picture files to xfer to GIGI
C  bckgnd -- set background color
      subroutine bckgnd ( c )
      byte c
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      if(.not.( c .lt. 0 ))goto 23000
C  assumes ASCII tests positive
      return
23000 continue
      call togrph
      if(.not.( c .le. 7 ))goto 23002
      write ( outlun , 100 ) c
100   format (' ' ,'S(I' , i1 ,')' )
      goto 23003
23002 continue
      write ( outlun , 200 ) c
200   format (' ' ,'S(I(' , a1 ,'))' )
23003 continue
      return
      end

C  bckmap -- backwards mapping: device coords to user coords
      subroutine bckmap ( ix , iy , x , y )
      integer ix , iy
      real x , y
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      x = ( ix - voffx ) / wvfacx
      y = ( iy - voffy ) / wvfacy
      return
      end
C  of bckmap

C  box -- subroutine to draw a box
      subroutine box ( xmin , ymin , xmax , ymax )
      real xmin , ymin , xmax , ymax
      call move ( xmin , ymin )
      call regis ('V(B)' )
C  begin a closed polygon
      call coord ( xmax , ymin )
      call coord ( xmax , ymax )
      call coord ( xmin , ymax )
      call regis ('(E)' )
C  end the polygon
      return
      end

C  charac -- send a graphics text string
      subroutine charac ( str )
      byte str ( 1 )
      byte newstr ( 100 )
      newstr ( 1 ) = 84
      newstr ( 2 ) = 39
      j = 3
      continue
       i = 1
23004 if(.not.(str(i).ne.0.and.j.lt.100-3))goto 23006
      newstr ( j ) = str ( i )
      j = j + 1
      if(.not.( str ( i ) .eq. 39 ))goto 23007
      newstr ( j ) = 39
      j = j + 1
23007 continue
23005 i=i+1
      goto 23004
23006 continue
      newstr ( j ) = 39
      newstr ( j + 1 ) = 59
      newstr ( j + 2 ) = 0
      if(.not.( j .gt. 3 ))goto 23009
      call regis ( newstr )
23009 continue
      return
      end

C  charf -- display a real number as text
      subroutine charf ( r )
      real r
      byte cbuf ( 20 )
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      call ftocg ( i , cbuf , 20 - 1 )
      call charac ( cbuf )
C send the character representation
      return
      end
C  of charf

C  chari -- display an integer
      subroutine chari ( i )
      integer i
      byte cbuf ( 11 )
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      call itoc ( i , cbuf , 11 - 1 )
      call charac ( cbuf )
C send the character representation
      return
      end
C  of chari

C  chrbgn -- begin a quoted character string
      subroutine chrbgn
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      if(.not.( .not. intx ))goto 23011
      call togrph
      write ( outlun , 100 )
100   format (' ' ,'T''' , $ )
      intx = . true .
23011 continue
      return
      end

C  chrend -- end a quoted character string
      subroutine chrend
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      intx = . false .
      write ( outlun , 100 )
100   format ('+' ,'''' )
      return
      end

C  chrsiz -- set character size parameters (character spacing is set by chrspc)
      subroutine chrsiz ( dir , iwdt , ihgt )
      integer dir , iwdt , ihgt
C   multipliers of basic x & y dmensions
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      idir = dir
      iiwdt = max0 ( 0 , min0 ( 16 , iwdt ) )
      iihgt = max0 ( 0 , min0 ( 25 , ihgt ) )
      call togrph
      write ( outlun , 100 ) idir , iiwdt
100   format (' ' ,';T(D' i4',S' i2')' )
      if(.not.( iihgt .gt. 0 ))goto 23013
      write ( outlun , 200 ) iihgt
23013 continue
200   format (' ' ,'(H' , i2')' )
      return
      end

C  chrspc -- set character spacing parameters
      subroutine chrspc ( ix , iy )
      byte xsign , ysign , xysign
      integer ix , iy
C  ix & iy are taken as relative amounts
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      xsign = xysign ( ix )
      ysign = xysign ( iy )
      call togrph
      write ( outlun , 100 ) xsign , ix , ysign , iy
100   format (' ' ,';T[' a1 , i4',' a1 , i4']' )
      return
      end

C  clear -- erase whole screen, set background color
      subroutine clear ( c )
      byte c
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      call togrph
      if(.not.( c .lt. 0 ))goto 23015
C  this assumes ascii char would test positive
      call regis ('S(E)' )
      goto 23016
23015 continue
      if(.not.( c .le. 7 ))goto 23017
      write ( outlun , 100 ) c
100   format (' ' ,'S(E,I' i1')' )
      goto 23018
23017 continue
      write ( outlun , 200 ) c
200   format (' ' ,'S(E,I(' a1'))' )
23018 continue
23016 continue
      return
      end

C  clreol -- clear to end of line in text mode
      subroutine clreol
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      if(.not.( .not. textsw ))goto 23019
      return
C don't do if in graphics-only mode
23019 continue
      call totext
      write ( outlun , 100 ) esc
100   format ('+' , $ , a1 ,'[K' , $ )
      return
      end
C  of clreol

C  color -- set color
      subroutine color ( c )
      call intens ( c )
C  pass the buck
      return
      end

C  coord -- output coordinates for an absolute point
      subroutine coord ( x , y )
      real x , y
      integer ix , iy , xmap , ymap
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      ix = xmap ( x )
      iy = ymap ( y )
      call togrph
      write ( outlun , 100 ) ix , iy
100   format (' ' ,'[' i3',' i3']' )
      return
      end

C  coordr -- output coordinates for a relative point
      subroutine coordr ( x , y )
      real x , y
      integer ix , iy , xmapr , ymapr
      byte xsign , ysign , xysign
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      ix = xmapr ( x )
      iy = ymapr ( y )
      xsign = xysign ( ix )
      ysign = xysign ( iy )
      call togrph
      write ( outlun , 100 ) xsign , ix , ysign , iy
100   format (' ' ,'[' a1 , i4',' a1 , i4']' )
      return
      end

C  cordin -- get GIGI's position readback
      integer function cordin ( ix , iy )
C  returns character, or -1, from "prspos"
      integer ix , iy , prspos , getstr , getln
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      byte str ( 31 )
      if(.not.( outlun .ne. orglun ))goto 23021
C  interact with original device
      cordin = 0
C  indicate "bad read"
      return
23021 continue
      call getln ( str , 30 , 0 )
C  get position, with no echo
      call putstr ( 47 , str , 32 )
      cordin = prspos ( str , ix , iy )
C  parse the string, return x & y
      return
      end
C  of cordin

C  curpos -- get current absolute (user coordinate) location of GIGI
      integer function curpos ( x , y )
      real x , y
      integer ix , iy , cordin
      call regis ('R(P)' )
      curpos = cordin ( ix , iy )
      if(.not.( curpos .ne. 0 ))goto 23023
      call bckmap ( ix , iy , x , y )
C  map to user coordinates
23023 continue
      return
      end
C  of curpos

C  devx -- disable user coordinate mapping for x (set for device coordinates)
      subroutine devx
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      mapx = . false .
      return
      end
C  of devx

C  devy -- disable user coordinate mapping for y (set for device coordinates)
      subroutine devy
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      mapy = . false .
      return
      end
C  of devy

C  draw -- draw a vector to an absolute point
      subroutine draw ( x , y )
      real x , y
      integer ix , iy , xmap , ymap
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      ix = xmap ( x )
      iy = ymap ( y )
      call togrph
      write ( outlun , 100 ) ix , iy
100   format (' ' ,'V[' i3',' i3']' )
      return
      end

C  drawr -- draw a vector to a relative point
      subroutine drawr ( x , y )
      real x , y
      integer ix , iy , xmapr , ymapr
      byte xsign , ysign , xysign
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      ix = xmapr ( x )
      iy = ymapr ( y )
      xsign = xysign ( ix )
      ysign = xysign ( iy )
      call togrph
      write ( outlun , 100 ) xsign , ix , ysign , iy
100   format (' ' ,'V[' a1 , i4',' a1 , i4']' )
      return
      end

C  erase -- clear a rectangular area on the screen
      subroutine erase ( xmin , ymin , xmax , ymax )
      real xmin , ymin , xmax , ymax
      call move ( xmax , ymax )
      call regis ('V(W(S1,E))' )
C  temporary shading + erase modes
      call coord ( xmax , ymin )
      call coord ( xmin , ymin )
      return
      end

C  escseq -- send an escape sequence
      subroutine escseq ( str )
      implicit integer ( a - z )
      byte str ( 1 )
C TOPS	logical ispack
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      if(.not.( .not. textsw ))goto 23025
      return
C  do nothing if in graphics-only mode
23025 continue
      call totext
C TOPS	if (! ispack (str))
      write ( outlun , 100 ) esc , ( str ( i ) , i = 1 , length ( str ) 
     *)
C TOPS	else
C TOPS		write (outlun, 200) esc, (str(i), i=1, lengp(str))
100   format ('+' , 255 ( a1 , $ ) )
C TOPS	200 format (NOSPACE, 255 (a, $))
      return
      end

C  getabs -- get current absolute (user coordinate) location of GIGI
      integer function getabs ( x , y )
      real x , y
      integer ix , iy , cordin
      call regis ('R(P(I))          ' )
      getabs = cordin ( ix , iy )
      if(.not.( getabs .ne. 0 ))goto 23027
C  zero indicates a bad read or "delete" key
      call bckmap ( ix , iy , x , y )
C  map to user coordinates
23027 continue
      return
      end
C  of getabs

C  getrel -- use GIGI's locator mode to get relative coordinates
      integer function getrel ( x , y )
      real x , y
      integer ix , iy , cordin
      real xold , yold
      call regis ('R(P,P(I))' )
      getrel = cordin ( ix , iy )
      if(.not.( getrel .eq. 0 ))goto 23029
      return
23029 continue
      call bckmap ( ix , iy , xold , yold )
      getrel = cordin ( ix , iy )
      if(.not.( getrel .eq. 0 ))goto 23031
      return
23031 continue
      call bckmap ( ix , iy , x , y )
      x = x - xold
      y = y - yold
      return
      end
C  of getrel

C  ginit -- initialize gpak
      logical function ginit ( lun )
      integer lun
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      integer getln , ttinnw
      byte buf ( 26 )
      byte sc1(4)
      byte sc0(4)
      data sc1 /'S','C','1',0/
      data sc0 /'S','C','0',0/
      esc = 155
      gon = . false .
      intx = . false .
      textsw = . true .
      if(.not.( lun .lt. 1 ))goto 23033
      outlun = 7
      open ( unit = outlun , name ='TT:' , type ='NEW' )
      goto 23034
23033 continue
      outlun = lun
C  all output goes to user-designated LUN
23034 continue
      orglun = outlun
C remember LUN used for initialization
      call assign ( 47 ,'LOCATOR.LOG' )
      call setup ( sc1 )
      continue
23035 if(.not.( ttinnw ( 0 ) .ne. 0 ))goto 23036
      continue
      goto 23035
23036 continue
C  flush type-ahead
      write ( outlun , 100 ) esc
C  determine terminal mode (VT52 or ANSI)
100   format ('+' , $ , a1 ,'Z' )
      i = getln ( buf , 25 , 0 )
      if(.not.( i .lt. 2 ))goto 23037
      i = i + getln ( buf ( i + 1 ) , 25 - i , 0 )
23037 continue
      ansitm = buf ( 2 ) .eq. 91
      ginit = ansitm
C  value returned is "true" if terminal in ANSI mode
      call setup ( sc0 )
      write ( outlun , 200 ) esc
C  enter ansi mode
200   format ('+' , $ , a1 ,'<' )
      vpt ( 1 ) = 0
      vpt ( 2 ) = 0
      vpt ( 3 ) = 767
      vpt ( 4 ) = 511
      wind ( 1 ) = 0 . 0
      wind ( 2 ) = 0 . 0
      wind ( 3 ) = 1 . 5
      wind ( 4 ) = 1 . 0
      call mapcmp
      call userx
      call usery
      call regis (';W(M1,V,A0,N0,P1(M2))S(N0)T(A0,I0,D0,S1)' )
      call clear ('D' )
      call intens ( 7 )
      call shade ( . false . )
      call move ( 0 . 75 , 0 . 5 )
      return
      end

C  intens -- set intensity (or color)
      subroutine intens ( c )
      byte c
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      if(.not.( c .lt. 0 ))goto 23039
C  assumes ASCII tests positive
      return
23039 continue
      call togrph
      if(.not.( c .le. 7 ))goto 23041
      write ( outlun , 100 ) c
100   format (' ' ,'W(I' , i1 ,')' )
      goto 23042
23041 continue
      write ( outlun , 200 ) c
200   format (' ' ,'W(I(' , a1 ,'))' )
23042 continue
      return
      end

C  itocl0 -- convert integer to character string with leading zeros
      subroutine itocl0 ( int , str , l )
      implicit integer ( a - z )
      integer int , l
C  number to convert
C  length of string to be created
      byte str ( 1 )
C  receives output
      byte ptemp ( 11 ) , temp ( 11 )
      encode ( 10 , 100 , ptemp ) int
100   format ( i 10 )
      call scopyl ( ptemp , temp , 10 )
      do 23043 i = 1 , l
      str ( i ) = temp ( i + ( 10 - l ) )
C  l must be no bigger than MAXINTLEN
      if(.not.( str ( i ) .eq. 32 ))goto 23045
      str ( i ) = 48
23045 continue
C  only works for unsigned numbers!
23043 continue
23044 continue
      return
      end
C  of itocl0

C  mapcmp -- compute mapping parameters from window and viewport
      subroutine mapcmp
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      real xdiv , ydiv
      xdiv = ( wind ( 3 ) - wind ( 1 ) )
      if(.not.( xdiv .eq. 0 . 0 ))goto 23047
      xdiv = 1 . 0
23047 continue
      ydiv = ( wind ( 4 ) - wind ( 2 ) )
      if(.not.( ydiv .eq. 0 . 0 ))goto 23049
      ydiv = 1 . 0
23049 continue
      wvfacx = ( vpt ( 3 ) - vpt ( 1 ) ) / xdiv
      wvfacy = ( vpt ( 4 ) - vpt ( 2 ) ) / ydiv
      voffx = vpt ( 1 ) - int ( wvfacx * wind ( 1 ) )
      voffy = vpt ( 2 ) - int ( wvfacy * wind ( 2 ) )
      return
      end

C  move -- move to an absolute point
      subroutine move ( x , y )
      real x , y
      integer ix , iy , xmap , ymap
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      ix = xmap ( x )
      iy = ymap ( y )
      call togrph
      write ( outlun , 100 ) ix , iy
100   format (' ' ,'P[' i3',' i3']' )
      return
      end

C  mover -- move to a relative point
      subroutine mover ( x , y )
      real x , y
      integer ix , iy , xmapr , ymapr
      byte xsign , ysign , xysign
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      ix = xmapr ( x )
      iy = ymapr ( y )
      xsign = xysign ( ix )
      ysign = xysign ( iy )
      call togrph
      write ( outlun , 100 ) xsign , ix , ysign , iy
100   format (' ' ,'P[' a1 , i4',' a1 , i4']' )
      return
      end

C  movtxt -- move the text cursor to a given column and row
      subroutine movtxt ( col , row )
      integer col , row
      byte rstr ( 2 ) , cstr ( 2 )
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)

      if(.not.( .not. textsw ))goto 23051
      return
C  do nothing if in graphics-only mode
23051 continue
      if(.not.( col .lt. 1 .or. row .lt. 1 .or. col .gt. 84 .or. row .gt
     *. 24 ))goto 23053
      return
23053 continue
      call totext
      call itocl0 ( row , rstr , 2 )
      call itocl0 ( col , cstr , 2 )
      write ( outlun , 100 ) esc , rstr , cstr
100   format ('+' /'+' , $ , a1 ,'[' , 2 a1 ,';' , 2 a1 ,'H' , $ )
      return
      end

C  pixmul -- set pixel multiplier
      subroutine pixmul ( pmul )
      integer pmul , pm
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      pm = max0 ( 1 , min0 ( pmul , 255 ) )
      write ( outlun , 100 ) pm
100   format (' ' ,';W(M' i4')' )
      return
      end
C  of pixmul

C  prspos -- parse a string containing REGIS absolute coodinates
      integer function prspos ( str , ix , iy )
C  returns 0 for bad read
C  -1 for good read w/no char
C  otherwise returns char
      byte str ( 1 )
      integer ix , iy
      byte intstr ( 14 )
C  assume biggest position is "[sxxxxx,syyyyy]"
      l = length ( str )
      continue
       i = l
23055 if(.not.(i.gt.0))goto 23057
C  from far end, look for initial "["
      if(.not.( str ( i ) .eq.'[' ))goto 23058
      goto 23057
23058 continue
23056 i=i-1
      goto 23055
23057 continue
      if(.not.( i .lt. 1 .or. i .gt. l - 4 ))goto 23060
C  assume smallest response is "[0,0]"
      goto 999
C  if "[" not found, input is bad
23060 continue
      if(.not.( i .gt. 1 ))goto 23062
C  if "[" not at start, return first char as value
      prspos = str ( 1 )
      goto 23063
23062 continue
C  or else, return -1
      prspos = - 1
23063 continue
      continue
       j = i
23064 if(.not.(j.le.l))goto 23066
C  find ending "]"
      if(.not.( str ( j ) .eq.']' ))goto 23067
      goto 23066
23067 continue
23065 j=j+1
      goto 23064
23066 continue
      if(.not.( j .gt. l ))goto 23069
      goto 999
C  if "]" not found, input is bad
23069 continue
      ll = j - i - 1
C  compute length of thing between the brackets
      if(.not.( ll .gt. 13 ))goto 23071
      goto 999
C  too long, error
23071 continue
      call scopyl ( str ( i + 1 ) , intstr , ll )
C make internal copy of insides
      call scopy ( intstr , intstr )
C make it a packed copy
      decode ( ll , 100 , intstr , err = 999 ) ix , iy
C TOPS	decode (ll, 100, intstr) ix, iy
100   format ( 2i255 )
      if(.not.( ix .lt. 0 .or. iy .lt. 0 ))goto 23073
      goto 999
23073 continue
      return
999   prspos = 0
      ix = - 1
      iy = - 1
      return
      end
C  of prspos

C  regis -- output a general regis string
      subroutine regis ( str )
      implicit integer ( a - z )
      byte str ( 1 )
      integer length , lengp
C TOPS	logical ispack
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      call togrph
C TOPS	if (!ispack(str))
      write ( outlun , 100 ) ( str ( i ) , i = 1 , length ( str ) )
C TOPS	else	# packed string
C TOPS		write (outlun, 200) (str(i), i=1, lengp(str))
100   format (' ' , 255 a1 , 255 ( /'+' , 255 a1 ) )
C TOPS	200 format (SS, 255 a (/ NOSPACE, 255 a) )
      return
      end

C  remark -- put a prompt or message at designated row on screen
      subroutine remark ( row , str )
      implicit integer ( a - z )
      integer row
      byte str ( 1 )
      integer i , l , length
C TOPS	logical ispack
C  clear designated row if length(str) == 0
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      if(.not.( .not. textsw ))goto 23075
      return
C  do nothing if in graphics-only mode
23075 continue
      call movtxt ( 1 , row )
C  always col #1
      call totext
C TOPS	if (! ispack (str))
      l = length ( str )
      if(.not.( l .eq. 0 ))goto 23077
      call clreol
      goto 23078
23077 continue
      write ( outlun , 100 ) ( str ( i ) , i = 1 , l )
23078 continue
C TOPS	else	# packed string
C TOPS	{	l = lengp (str)
C TOPS		if (l == 0)
C TOPS			call clreol
C TOPS		else
C TOPS			write (outlun, 200) (str(i), i=1, l)
C TOPS	}
100   format ('+' , 255 ( a1 , $ ) )
C  no CR at end, no LF at start (to avoid scrolling)
C TOPS	200 format (NOSPACE, 255 (a, $))
      return
      end

C  setup -- issue GIGI terminal setup commands
      subroutine setup ( str )
      implicit integer ( a - z )
      byte str ( 1 ) , bs
C TOPS	logical ispack
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      if(.not.( .not. textsw ))goto 23079
      return
C  do nothing if in graphics-only mode
23079 continue
      bs = 92
      call totext
C TOPS	if (! ispack (str))
      write ( outlun , 100 ) esc , ( str ( i ) , i = 1 , length ( str ) 
     *) , esc , bs
C TOPS	else
C TOPS	{	write (outlun, 200) esc, (str(i), i=1, lengp(str))
C TOPS		write (outlun, 300) esc, bs
C TOPS	}
100   format ('+' , a1 ,'Pr' , 255 ( a1 , $ ) )
C TOPS	200 format ('+', CHARFORMAT, 'Pr', 255 (a,$))
C TOPS	300 format ('+', 2 CHARFORMAT, $)
      return
      end

C  shade -- turn shading on or off, set y base for shading if turned on
      subroutine shade ( sw , y )
      real y
      logical sw
      integer iy , ymap
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      if(.not.( .not. sw ))goto 23081
      call regis ('W(S0)' )
      goto 23082
23081 continue
      call togrph
      iy = ymap ( y )
      write ( outlun , 100 ) iy
100   format (' ' ,'W(S[,' , i3 ,'])' )
23082 continue
      return
      end

C  stglun -- set the logical unit number for graphics output
      subroutine stglun ( lun , sw )
      integer lun
      logical sw
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      call totext
      if(.not.( lun .lt. 1 ))goto 23083
C  default to 7, same as in GINIT
      outlun = 7
      goto 23084
23083 continue
      outlun = lun
23084 continue
      if(.not.( outlun .eq. orglun ))goto 23085
C original device is considered always interactive
      textsw = . true .
      goto 23086
23085 continue
      textsw = sw
23086 continue
      return
      end

C  togrph -- put the terminal in graphics mode (if not already there)
      subroutine togrph
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      if(.not.( .not. gon ))goto 23087
      if(.not.( textsw ))goto 23089
      write ( outlun , 100 ) esc
23089 continue
100   format ('+' , a1 ,'Pp' )
      gon = . true .
      intx = . false .
23087 continue
      return
      end

C  totext -- put the terminal in text mode (if not there now)
      subroutine totext
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      if(.not.( gon ))goto 23091
      if(.not.( intx ))goto 23093
      call chrend
23093 continue
      if(.not.( textsw ))goto 23095
      write ( outlun , 100 ) esc
23095 continue
100   format (' ' , a1 ,'\' , $ )
      gon = . false .
23091 continue
      return
      end

C  userx -- enable user to device coordinate mapping for x
      subroutine userx
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      mapx = . true .
      return
      end
C  of userx

C  usery -- enable user to device coordinate mapping for y
      subroutine usery
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      mapy = . true .
      return
      end
C  of usery

C  viewpt -- set viewport
      subroutine viewpt ( xmin , ymin , xmax , ymax )
      integer xmin , ymin , xmax , ymax
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      vpt ( 1 ) = max0 ( 0 , min0 ( 767 , xmin ) )
      vpt ( 3 ) = max0 ( 0 , min0 ( 767 , xmax ) )
      vpt ( 2 ) = max0 ( 0 , min0 ( 511 , ymin ) )
      vpt ( 4 ) = max0 ( 0 , min0 ( 511 , ymax ) )
      call mapcmp
      return
      end

C  window -- set window
      subroutine window ( xmin , ymin , xmax , ymax )
      real xmin , ymin , xmax , ymax
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      wind ( 1 ) = xmin
      wind ( 3 ) = xmax
      wind ( 2 ) = ymin
      wind ( 4 ) = ymax
      call mapcmp
      return
      end

C  xmap -- user to device mapping for x
      integer function xmap ( x )
      real x
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      if(.not.( mapx ))goto 23097
      xmap = max0 ( vpt ( 1 ) , min0 ( vpt ( 3 ) , int ( 0 . 5 + x * wvf
     *acx ) + voffx ) )
      goto 23098
23097 continue
      xmap = max0 ( 0 , min0 ( 767 , int ( x + 0 . 5 ) ) )
23098 continue
      return
      end

C  xmapr -- user to relative coordinate mapping for x
      integer function xmapr ( x )
      real x
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      if(.not.( mapx ))goto 23099
      xmapr = max0 ( - vpt ( 3 ) , min0 ( vpt ( 3 ) , int ( x * wvfacx +
     * 0 . 5 ) ) )
      goto 23100
23099 continue
      xmapr = max0 ( - 767 , min0 ( 767 , int ( x + 0 . 5 ) ) )
23100 continue
      return
      end

C  xfrpic -- transfer a picture file to GIGI
      logical function xfrpic ( fn )
C  "true" if successful, "false" otherwise
      implicit integer ( a - z )
      byte fn ( 1 )
C  file name
C  the following are funtions defined in RATLIB
      logical openf , openio , ispack , putstr , ptprmt
      integer getstr , scopy , scopyl , length , trim , rpad , lpad , is
     *comp , indexx , rindex , ctoi , equal , stemeq , itoc , type , spl
     *ice , upper , lower , makeuc , makelc , cvt , lengp , u n p a c k 
     *, p a c k , skipbl , findbl , ftocg , strsub , matchs , puttyp , p
     *rsdir
      integer ttin , ttinnw , getln , prmtgt
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      byte buf ( 252 )
      byte pic(4)
      data pic /'P','I','C',0/
      call puttyp ( fn , buf , pic )
C  default file type to ".pic"
      xfrpic = openf ( 46 , buf , 2 )
      if(.not.( .not. xfrpic ))goto 23101
      return
C  open error
23101 continue
      call togrph
      continue
23103 continue
C  until EOF
      if(.not.( getstr ( 46 , buf , 250 ) .lt. 0 ))goto 23106
      goto 23105
23106 continue
      call putstr ( outlun , buf , 32 )
23104 goto 23103
23105 continue
      call totext
C  force this because the file may have done this
      call closef ( 46 )
      return
      end
C  of xfrpic

C  ymap -- user to device mapping for y
      integer function ymap ( y )
      real y
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      if(.not.( mapy ))goto 23108
C  a mapped y is always even
      ymap = max0 ( vpt ( 2 ) , min0 ( vpt ( 4 ) , int ( 0 . 5 + y * wvf
     *acy ) + voffy ) ) .and. . not . 1
      goto 23109
23108 continue
      ymap = max0 ( 0 , min0 ( 511 , int ( 0 . 5 + y ) ) )
23109 continue
      return
      end

C  ymapr -- user to relative coordinate mapping for y
      integer function ymapr ( y )
      real y
      common / gpklun / outlun , orglun , textsw , esc
      integer outlun
C  logical unit number for output
      integer orglun
C  logical unit number at initialization time
      logical textsw
C  if NO, inhibits all non-ReGIS output
      byte esc
C  ESCAPE (a constant)
      common / gpkcom / gon , intx , mapx , mapy , ansitm , vpt , wind ,
     * voffx , voffy , wvfacx , wvfacy
      logical gon , intx
      logical mapx , mapy
      logical ansitm
      integer vpt ( 4 )
      real wind ( 4 )
      integer voffx , voffy
      real wvfacx , wvfacy
      if(.not.( mapy ))goto 23110
      ymapr = max0 ( - vpt ( 4 ) , min0 ( vpt ( 4 ) , int ( y * wvfacy +
     * 0 . 5 ) ) )
      goto 23111
23110 continue
      ymapr = max0 ( - 511 , min0 ( 511 , int ( y + 0 . 5 ) ) )
23111 continue
      return
      end

C  xysign -- produce sign character for relative coordinates
      integer function xysign ( c )
C  actually returns a character
      integer c
      if(.not.( c .ge. 0 ))goto 23112
      xysign = 43
      goto 23113
23112 continue
      xysign = 32
C  for neg numbers, FORTRAN supplies the sign
23113 continue
      return
      end
