c
c Title: READKEY
c R.F. Wrenn, January 1982
c
c This subroutine is similar to the old MIST subroutine BEEKEY.  You call it
c to read a single character from the terminal keyboard.  If a key has been
c struck, then the ascii code is returned.  Otherwise, 0 (ascii null) is 
c returned.
c
      subroutine readkey (char_buf)
      implicit integer*4 (a-z)
      external ss$_normal, io$_ttyreadall, io$m_timed, io$m_noecho
      external ss$_wasclr, ss$_wasset
      common /read_key_state/ initialized, term_chan,
     .                        keyboard_ef, read_func
      logical*1 initialized, char_buf, io_buf
      integer*4 no_time
      data no_time /0/
c
c Error masks
c
      integer*4 errorv(2)
      data errorv(1) /'000F0001'x/
      integer*2 iosb(4)
      data status /1/, bytecnt /2/, terminator /3/, terminsiz /4/
c
c Terminator table with no terminators
c
      integer*4 no_terminators(2), term_mask(8)
      data no_terminators /32,0/
      data term_mask /'00000000'x,'00000000'x,'00000000'x,'00000000'x,
     .                '00000000'x,'00000000'x,'00000000'x,'00000000'x/
      no_terminators(2) = %loc(term_mask)
c
c Note: This code is VAX FORTRAN specific.  It uses the fact that all logical
c       variables are initialized to .false. to execute this code once.
c
      if (.not. initialized) then
         initialized = .true.
c
c Assign an io channel for TT:
c
         errorv(2) = sys$assign ('TT', term_chan,,)
         if (errorv(2) .ne. %loc(ss$_normal)) then
            type *,'Unable to assign TT: for output.'
            call sys$putmsg (errorv,,)
            call sys$exit (%val(errorv(2)))
            endif
c
c Allocate an event flag and clear it
c
         errorv(2) = lib$get_ef(keyboard_ef)
         if (errorv(2) .ne. %loc(ss$_normal)) then
            type *,'Unable to allocate event flag.'
            call sys$putmsg (errorv,,)
            call sys$exit (%val(errorv(2)))
            endif
         errorv(2) = sys$clref (%val(keyboard_ef))
         if (.not. (errorv(2) .eq. %loc(ss$_wasclr) .or.
     .              errorv(2) .eq. %loc(ss$_wasset)     )) then
            type *,'Unable to clear event flag.'
            call sys$putmsg (errorv,,)
            call sys$exit (%val(errorv(2)))
            endif
         read_func = %loc(io$_ttyreadall) .or. %loc(io$m_timed)
     .                                    .or. %loc(io$m_noecho)
         endif
c
c Initiate a single character read
c
      errorv(2) = sys$qiow (%val(keyboard_ef), %val(term_chan),
     .                     %val(read_func), iosb, , ,
     .                     io_buf, %val(1),
     .                     %val(no_time), no_terminators,,)
c
c Ignore any errors
c
      If (iosb(status) .eq. %loc(ss$_normal) .and. 
     .    iosb(bytecnt) .eq. 1                    ) then
         char_buf = io_buf
      else
         char_buf = 0
         endif
      return
      end
