	SUBROUTINE DHELP (HELPTYPE)

C This subroutine is part of the DEFAULT package.

C Author:	Joseph L. BINGHAM
C		ManTech International
C		2320 Mill Road
C		Alexandria, VA 22314
C		(703) 838-5600

	IMPLICIT INTEGER (A-Z)
	CHARACTER*(*) HELPTYPE
	LOGICAL FIRSTTIME

	FIRSTTIME = .TRUE.

 100	CALL MOREHELP (FIRSTTIME, HELPTYPE, IHELPTYPE)
	FIRSTTIME = .FALSE.
	HELPTYPE = ' '
	TYPE*, ' '

	GOTO (1000, 2000, 3000, 4000), IHELPTYPE

 1000	CONTINUE
	TYPE*,'The D command makes the DCL $SET DEFAULT and $SHOW DEFAULT'
	TYPE*,'easy to use.  It will optionally display the default file'
	TYPE*,'protection each time the default directory is displayed.'
	TYPE*,' '
	TYPE*,'USAGE:'
	TYPE*,'      Command                  Effect'
	TYPE*,' '
	TYPE*,'$D logname             Changes default to the logical name
	1 translation'
	TYPE*,'                         of DIR$logname if it is translatable.'
	TYPE*,' '
	TYPE*,'$D diskname:dirname    Changes default to diskname:[dirname].'
	TYPE*,'                       Diskname or dirname may be null for
	1 no change.'
	TYPE*,' '
	TYPE*,'$D ...                 Changes default to the level indicated
	1 by the '
	TYPE*,'                         number of periods in the current tree.'
	TYPE*,' '
	TYPE*,'$D,one-char-abbrev or  Changes default to a directory defined
	1 by a one-'
	TYPE*,' $D,two-char-abbrev      character abbreviation.  The
	1 sets abbreviated'
	TYPE*,'                         may be displayed by entering "D," or
	1 "D,,".'
	TYPE*,' '
	TYPE*,'Special D comma commands:'
	TYPE*,' '
	TYPE*,'$D,D           Sets default to your login directory.'
	TYPE*,'$D,H           Types this information.'
	TYPE*,'$D,N           Sets default to the next directory in the tree.'
	TYPE*,'$D,,N          Sets default to the next first line directory.'
	TYPE*,'$D,S           Saves the current directory.  Return with $D,X.'
	TYPE*,'$D,R           Returns to the last directory exited with a D
	1 command.'
	TYPE*,'$D,T           Toggles the switch controlling the
	1 SHOW PROTECTION/DEFAULT'
	TYPE*,'$D,X           See D,S.'
	TYPE*,' '
	TYPE*,'Commands may be strung together as in $D,R..SUB1'

	GOTO 100

 2000	CONTINUE
	TYPE*,'D comma abberviations are as follows:'
	TYPE*,' '
	TYPE*,'$D,A         DRB0:[MANAGER]'
	TYPE*,'$D,B         DRB0:[BINGHAM]'
	TYPE*,'$D,C         DRB0:[DECUS.LUG.CHESS]'
	TYPE*,'$D,D         login default directory'
	TYPE*,'$D,E         SYS$SYSDISK:[SYSEXE]'
	TYPE*,'$D,G         DRB1:[VAX79A.GAMES]'
	TYPE*,'$D,H         help (general)'
	TYPE*,'$D,I         SYS$SYSDISK:[DUP11]'
	TYPE*,'$D,J         SYS$SYSDISK:[SYSPROG]'
	TYPE*,'$D,L         SYS$SYSDISK:[DUP11.LOGS]'
	TYPE*,'$D,M         SYS$SYSDISK:[SYSMGR]'
	TYPE*,'$D,N         the next directory in a preorder traversal'
	TYPE*,'$D,O         SYS$SYSDISK:[OPERATOR]'
	TYPE*,'$D,P         SYS$SYSDISK:[SYSPG1]'
	TYPE*,'$D,R         last directory exited with a D command'
	TYPE*,'$D,S         sets directory for use by D,X'
	TYPE*,'$D,T         toggles SHOW PROTECTION/DEFAULT'
	TYPE*,'$D,V         DRB1:[VAX000]'
	TYPE*,'$D,X         directory set with D,S'

	GOTO 100

 3000	CONTINUE
	TYPE*,'D comma comma abbreviations are as follows:'
	TYPE*,' '
	TYPE*,'$D,,A        SYS$SYSDISK:[APL]'
	TYPE*,'$D,,C        DRB1:[SYSPG1.CRASH]'
	TYPE*,'$D,,E        SYS$SYSDISK:[SYSERR]'
	TYPE*,'$D,,H        SYS$SYSDISK:[HDL]'
	TYPE*,'$D,,I        SYS$SYSDISK:[HDL.CTL]'
	TYPE*,'$D,,L        DRB0:[LEARNC]'
	TYPE*,'$D,,M        SYS$SYSDISK:[SYSPROG.MAR]'
	TYPE*,'$D,,N        next first line directory'
	TYPE*,'$D,,S        DRB1:[SHSYS]'
	TYPE*,'$D,,T        SYS$SYSDISK:[SYSPROG.TTINFO]'
	TYPE*,'$D,,U        DRB0:[TSOUSER]'

	GOTO 100

 4000	CONTINUE
	RETURN

	END
	SUBROUTINE MOREHELP (FIRSTTIME, HELPTYPE, IHELPTYPE)

C This subroutine is part of the DEFAULT package.

C Author:	Joseph L. BINGHAM
C		ManTech International
C		2320 Mill Road
C		Alexandria, VA 22314
C		(703) 838-5600

	IMPLICIT INTEGER (A-Z)
	CHARACTER*(*) HELPTYPE
	CHARACTER*2 ANS
	LOGICAL FIRSTTIME

	IF (.NOT. FIRSTTIME) THEN

	TYPE*,' '
	TYPE*,'Enter "H" for help, "E" to exit, "," to see the one-comma'
	TYPE*,'abbreviations or ",," to see the two-comma abbreviations.'

 100	ACCEPT 501, ANS
 501	FORMAT (A2)

	ENDIF

	IF (HELPTYPE .EQ. 'GENERAL' .OR. ANS .EQ. 'H' .OR. ANS .EQ. 'h') THEN

		IHELPTYPE = 1

	ELSE IF (HELPTYPE .EQ. 'COMMA' .OR. ANS .EQ. ',') THEN

		IHELPTYPE = 2

	ELSE IF (HELPTYPE .EQ. 'TWO COMMA' .OR. ANS .EQ. ',,') THEN

		IHELPTYPE = 3

	ELSE IF (ANS .EQ. 'E' .OR. ANS .EQ. 'e') THEN

		IHELPTYPE = 4

	ELSE

		TYPE*,'Please answer "H", "E", "," or ",,"'
		GOTO 100

	ENDIF

	RETURN

	END
